"6809"	  LIST
	  TITLE     "Low Level TNC Routines by Margaret Morrison, KV7D"

;	  Copyright, (C) Margaret S. Morrison, 1982,1983

;	  Permission is granted for use so long as this notice of
;	  authorship is retained in the source code.

	  GLOBAL    ACY,ACX,MON,STACK_

	  INCLUDE   PARAM
	  INCLUDE   RAMTAB
	  TITLE     "Entry points -- TNC LLR, Margaret Morrison"

	  PROG

	  COPYRIGHT			;notice for C000 prom

	  DIRECT
	  SETDP     PAGE
	  GLOBAL    GETCMD,WRAPAI,FLSHAI,GETAI,PUTAO,GETHI,PUTHO
	  GLOBAL    PUTNV,PUTNVB,RESET1,CWID,SETMOD
	  GLOBAL    CALCFC,LLRINF
	  GLOBAL    WRITE5,WRITE8,WRITE10,WRITE15,WRITE20,WRITE128
	  GLOBAL    WRITE1,WRITELAST,WRITEBLK,WRITECR

	  GLOBAL    Write,Setint,Getlin
	  GLOBAL    Wrthex,Enhex,Dehex,Wrtbyt
	  GLOBAL    Bltrn,Inton,Intoff,Vinit,Hinit

	  EXTERNAL  PROMPT,PROLEN,BTINIT,BTLEN
	  EXTERNAL  Monbeg

GETCMD	  LBRA	    GETCMD_
WRAPAI	  LBRA	    WRAPAI_
FLSHAI	  LBRA	    FLSHAI_
GETAI	  LBRA	    GETAI_
PUTAO	  LBRA	    PUTAO_
GETHI	  LBRA	    GETHI_
PUTHO	  LBRA	    PUTHO_
PUTNV	  LBRA	    PUTNV_
PUTNVB	  LBRA	    PUTNVB_
RESET1	  LBRA	    RESET
CWID	  LBRA	    CWID_
SETMOD	  LBRA	    SETMOD_
CALCFC	  LBRA	    CALCFC_
WRITE1	  LBRA	    WRITE1_
WRITE5
WRITE8
WRITE10
WRITE15
WRITE20
WRITE128  LBRA	    WRITEN_
WRITELAST LBRA	    WRITECR_
WRITEBLK  LBRA	    WRITEBLK_
LLRINF	  LBRA	    LLRINF_

Write	  LBRA	    WRITE
Setint	  LBRA	    SETINT
Getlin	  LBRA	    GETLIN
Wrthex	  LBRA	    WRTHEX
Enhex	  LBRA	    ENHEX
Dehex	  LBRA	    DEHEX
Wrtbyt	  LBRA	    WRTBYT
Bltrn	  LBRA	    BLTRN
Inton	  LBRA	    INTON
Intoff	  LBRA	    INTOFF
Vinit	  LBRA	    VINIT
Hinit	  LBRA	    HINIT

; GETHI (DEST,N)

GETHI_	  TFR	    D,Y			;get destination pointer
	  LDD	    ,X			;get count
	  LBNE	    GETPKT
	  RTS				;no zero strings

; PUTHO (SOURCE,N)

PUTHO_	  TFR	    D,Y			;get pointer in Y
	  LDD	    ,X			;get count in D
	  LBNE	    SNDPKT
	  RTS				;no zero packet

; PUTNV

PUTNV_	  CLRA				;temporary copy of NOVRAM
	  LBRA	    SAVNOV

; PUTNVB

PUTNVB_   LDA	    #1			;permanent copy of NOVRAM
	  LBRA	    SAVNOV

; WRAPAI (RP,N',RP')

WRAPAI_   PSHS	    X,Y			;save addresses of returns
	  TFR	    D,X			;get old pointer
	  LDX	    ,X
	  LBSR	    FINDPK		;find beginning of pkt
	  TFR	    Y,D
	  PULS	    Y,U			;save count
	  STD	    ,Y			;return count
	  STX	    ,U			;return pointer
	  RTS

; FLSHAI (RP')

FLSHAI_   PSHS	    CC
	  TFR	    D,X			;get pointer
	  LDD	    ,X
	  STD	    AIRP		;save hi level copy
	  TFR	    D,X
	  SEI
	  LDY	    #SCI_BF
	  TST	    DBG_FL
	  BNE	    FLSH_1
	  LDY	    #TTI_BF

FLSH_1	  SUBD	    US,Y		;calculate correction
	  BGE	    FLSH_2
	  ADDD	    LN,Y
FLSH_2	  ADDD	    CT,Y
	  STD	    CT,Y		;update count
	  STX	    US,Y
	  CMPX	    PK,Y		;see if time to move fence
	  BNE	    FLSHND
	  TST	    OPQ_FL
	  BEQ	    FLSH_3
	  CLR	    OPQ_FL
	  LDX	    TMP_PK		;move past non-transparent packets
	  STX	    PK,Y
	  CMPX	    US,Y
	  BEQ	    FLSH_3
	  LDA	    TRN_FL
	  CMPA	    #5			;special case for 2 kinds of leftovers
	  BLT	    FLSHND
	  BGT	    FLSH_X
	  INC	    TRN_FL
	  BRA	    FLSHND

FLSH_3	  LDA	    TRN_FL		;test for transparent mode
	  BEQ	    FLSHND
	  INCA
	  CMPA	    #6			;check transparent waiting state
	  BLT	    FLSH_5
	  BEQ	    FLSH_4
FLSH_X	  CLR	    PAC_FL		;done with transparent mode
	  CLR	    TRN_FL
	  BRA	    FLSHND

FLSH_4	  STA	    TRN_FL		;final wait state
FLSH_5	  LDX	    TMP_PK
	  TST	    PAC_FL		;test fence flag
	  BLE	    FLSH_6
	  LDX	    IN,Y		;timeout -- get input pointer
	  STX	    TMP_PK
	  NEG	    PAC_FL
	  LDB	    PKT_LN+1		;update packet count
	  STB	    PKT_CT
	  CLR16     TN_CLK
	  CMPX	    US,Y
	  BNE	    FLSH_7
FLSH_6	  CLR	    PAC_FL
FLSH_7	  STX	    PK,Y		;set fence
FLSHND	  TST	    DBG_FL
	  BNE	    FLSH_8
	  LBSR	    XONREQ
FLSH_8	  PULS	    CC,PC

; GETAI (RP,COUNT,DEST,OFFSET)

GETAI_	  PSHS	    D			;save RP address
	  LDD	    ,U			;get offset
	  LEAY	    D,Y			;get destination
	  LDD	    ,X			;get count
	  BNE	    GETA_1
	  PULS	    D,PC
GETA_1	  PULS	    X
	  LDX	    ,X
	  LBRA	    READPK

; WRITEBLK

WRITEBLK_ LDA	    #40Q
	  BRA	    WRITE1_

; WRITELAST

WRITECR
WRITECR_  LDA	    #CR

; WRITE1 (CHAR)

WRITE1_   PSHS	    A,B,Y
	  TFR	    S,Y
	  LDD	    #1
	  LBSR	    WRITE
	  PULS	    A,B,Y,PC

; WRITEn (SOURCE,N)

WRITEN_   TFR	    D,Y
	  TFR	    X,D
	  CMPD	    #0
	  LBNE	    WRITE
	  RTS

; PUTAO (SOURCE,OFFSET,N)

PUTAO_	  LDX	    ,X			;get offset
	  LEAX	    D,X			;add to source
	  EXG	    X,Y			;move to Y
	  LDD	    ,X			;get count
	  LBNE	    WRITE
	  RTS				;no zero strings

; GETCMD (DEST,N')

GETCMD_   TFR	    D,Y			;get destination
	  LBSR	    READLN
	  STD	    ,X			;store count
	  RTS

; SETMOD				;change to converse mode

SETMOD_   PSHS	    CC
	  SEI
	  TST	    DBG_FL		;do nothing if in converse
	  BNE	    SETM_1
	  PULS	    CC,PC

SETM_1	  LDX	    TTI_IN		;check if typein in progress
	  CMPX	    TTI_CR
	  BEQ	    SETM_a
	  INC	    CHG_FL		;set flag
	  PULS	    CC,PC

SETM_a	  SEI
	  TST	    DIA_FL
	  BNE	    SETM_b
	  LDA	    #CMD
	  LBSR	    SETBIT

SETM_b	  CLI
	  CLR	    CTO_FL		;change to converse mode
	  TST	    TRN_FL
	  BNE	    SETM_3
	  TST	    OPQ_FL
	  BNE	    SETM_3

	  CLR	    DBG_FL		;clear flag
	  LDY	    #INLIST		;save command input pointers
	  LDX	    #CMLIST
	  LDB	    #INLEN
	  LBSR	    BLTRN
	  LDX	    #INLIST		;get converse input pointers
	  LDY	    #SCILST
	  LDB	    #INLEN
	  LBSR	    BLTRN

	  TST	    QSO_FL
	  BNE	    SETM_2		;go into transparent mode
	  LDX	    #TRNCHR		;set interrupt
	  STX	    TTI_IV
	  CLR16     TN_CLK
	  INC	    TRN_FL
	  CLR	    PAC_FL
	  LDX	    TTI_PK		;look for leftover packets
	  STX	    TMP_PK		;set temp fence
	  CMPX	    TTI_US
	  BEQ	    SETM_2
	  INC	    OPQ_FL
	  DEC	    PAC_FL		;set flags for leftovers
SETM_2	  PULS	    CC,PC

SETM_3	  LDA	    #1
	  STA	    QSO_FL
	  STA	    COM_FL		;too complicated -- don't enter
	  PULS	    CC
	  LDD	    #FAILNM		;don't go into converse/transp
	  LDY	    #FAILMS
	  LBSR	    WRITE
	  RTS

; CALCFC				;update counters

CALCFC_   LDD	    TTO_OU		;calculate output free count
	  SUBD	    TTO_US
	  BGT	    CALC_1
	  SUBD	    TTO_BF
	  ADDD	    TTO_TP
CALC_1	  STD	    AOFC
	  LDD	    PKO_OU		;calculate packet free count
	  SUBD	    PKO_US
	  BGT	    CALC_2
	  SUBD	    PKO_BF
	  ADDD	    PKO_TP
CALC_2	  SUBD	    #2
	  STD	    HOFC
	  RTS

; CWID

CWID_	  SEI				;start CW manually
	  TST	    IDG_FL		;no re-enter
	  BNE	    CWID_1
	  DEC	    IDG_FL		;send ID on next timer IRQ
CWID_1	  CLI
	  RTS

; LLRINF (LS)

LLRINF_   SEI
	  TST	    DIA_FL		;test ok to output
	  BNE	    LLRI_1
	  INCB
	  PSHS	    B
	  LDA	    >PIA
	  ANDA	    #(DCD.OR.ACT)
	  ORA	    ,S+
	  STA	    >PIA
LLRI_1	  CLI
	  RTS

	  TITLE     "Main program -- TNC LLR, Margaret Morrison"

	  COMN
USTACK	  FCB	    50H			;CC
	  FCB	    IOPAGE		;DP
	  FDB	    0			;X
	  FDB	    0			;Y -- bottom of buffer space

	  FCB	    ADR0_5		;A data for VIA B
	  FCB	    STORE+NOV_WE+ADR6	;B data for VIA A

	  FCB	    6			;A number of end flags
	  FCB	    PAGE		;DP
	  FDB	    TER_BF		;X -- index to pointers
	  FDB	    BUFTOP		;Y -- bottom of buffer space

	  FDB	    TERBUF		;fast input buffer length
	  FDB	    ECOBUF		;echo output buffer

	  FDB	    TINBUF		;data I/O buffers
	  FDB	    TOUBUF

	  FDB	    PKIBUF		;packet buffers
	  FDB	    PKOBUF

	  FDB	    MNLIST
	  FDB	    MINBUF		;monitor I/O buffers
	  FDB	    MOUBUF

	  FDB	    CINBUF		;command I/O buffers

	  FCB	    VECLEN		;B
	  FDB	    VECTAB		;X
	  FDB	    EATCHR		;terminal input
	  FDB	    PUTCHR		;terminal output
	  FDB	    TIMOUT		;clock
	  FDB	    PACKET		;packet input
	  FDB	    DISMIS		;default parallel interrupt
	  FDB	    TEST		;allow normal interrupts

	  FDB	    MONBUF		;linear buffers
	  FDB	    COMBUF

	  FCB	    NFLAG		;B  number of flags
	  FDB	    FLAGS		;X  address of flags

	  FCB	    HIZNUM		;B
	  FDB	    HIZERO		;X

	  FCB	    MONLEN		;zero for high-level
	  FDB	    MON

	  FDB	    BECTXT		;X beacon text string
	  FDB	    BTINIT		;Y default beacon text

; Initialize buffers, flags

	  PROG
	  SETDP     IOPAGE
RAMTST	  LDA	    ,X			;loop to test RAM
	  COMA				;test both states of all bytes
	  STA	    ,X
	  CMPA	    ,X
	  BNE	    RAMEND		;exit on first failure
	  COMA
	  STA	    ,X
	  CMPA	    ,X+
	  BEQ	    RAMTST

	  LEAX	    -1,X		;correct index
RAMEND	  RTS

RESET	  LDS	    #STACK_		;init stack at top of RAM
	  LDU	    #USTACK		;initialize constants from user stack
	  PULU	    CC,DP,X,Y

LOOP	  LEAY	    -1,Y		;wait loop
	  BNE	    LOOP

; Test RAM and return size    ***

	  BSR	    RAMTST		;test low RAM section
	  STX	    >RAMTOP
	  CMPS	    >RAMTOP
	  BLE	    RAMOK
	  LDS	    >RAMTOP

RAMOK	  LDX	    #4000H		;test high RAM section
	  STX	    >HIBOT
	  BSR	    RAMTST
	  STX	    >HITOP
	  CMPX	    #8000H
	  BNE	    RAMDON

	  LDX	    #4000H		;test just how bit it is
	  LDY	    #6000H		;test for 16k
	  LDA	    ,X
	  LDB	    ,Y
	  COMA
	  STA	    ,X
	  CMPB	    ,Y
	  BEQ	    RAMDON
	  STY	    >HITOP		 ;8k or less

	  LDY	    #5000H		;test for 8k
	  LDB	    ,Y
	  COMA
	  STA	    ,X
	  CMPB	    ,Y
	  BEQ	    RAMDON
	  STY	    >HITOP		 ;4k or less

	  LDY	    #4800H		;test for 4k
	  LDB	    ,Y
	  COMA
	  STA	    ,X
	  CMPB	    ,Y
	  BEQ	    RAMDON
	  STY	    >HITOP		 ;2k & probably not less

; Initialize NOVRAM interface and read NOVRAM

RAMDON	  PULU	    A,B
	  CLR	    >DEF_FL		;clear flags
	  CLR	    >ERR_FL
	  STB	    VIAA		;preset output bits
	  STD	    DDRB		;set data-direction registers
	  CMPD	    DDRB
	  BEQ	    RSET_0
	  LDB	    #NOVIA		;via failure
	  STB	    >ERR_FL
	  BRA	    RSET_1

RSET_0	  LDA	    PORTA
	  ANDA	    #SWIT_1		;test switch 1
	  BEQ	    RSET_1

	  LBSR	    GETNOV		;read NOVRAM
	  BRA	    RSET_2

; Insert subroutines here to optimize addressing

	  SETDP     PAGE
PKINIT	  LDB	    #4			;init incoming packet buffer
	  BRA	    BFIN_1

BFINIT	  BSR	    ININIT
	  LDB	    #DFLNM		;init flags after input buffer
	  BSR	    CLEAR		;do flags

OUINIT	  LDB	    #3
BFIN_1	  STY	    ,X++		;store pointer
	  DECB
	  BNE	    BFIN_1		;loop
	  TFR	    Y,D
	  ADDD	    ,U++
	  TFR	    D,Y
	  SUBD	    #1
	  STD	    ,X++		;save top of buffer
	  RTS

ININIT	  LDB	    #5			;init output & input pointers
	  BSR	    BFIN_1		;init 5 pointer + top
	  LDD	    -2,U
	  STD	    ,X++		;save length pointer
	  SUBD	    #0AH		;save XON/XOFF data
	  STD	    ,X++
	  SUBD	    #0AH
	  STD	    ,X++
	  RTS

CLEAR	  CLR	    ,X+			;zero a block of memory
	  DECB
	  BNE	    CLEAR
	  RTS

	  SETDP     IOPAGE
; Continue reset procedures

RSET_1	  LBSR	    GETDEF		;read default NOVRAM
	  INC	    >DEF_FL

	  SETDP     PAGE
RSET_2	  PULU	    A,DP,X,Y
	  STA	    FLG_NM
	  BSR	    OUINIT		;terminal buffer
	  BSR	    OUINIT		;echo buffer

	  BSR	    BFINIT		;data buffers in I/O area
	  LDD	    -2,U
	  STD	    AOFC
	  BSR	    PKINIT		;incoming packet buffer
	  LDD	    -2,U		;space available
	  STD	    HOFC
	  BSR	    OUINIT		;outgoing packet buffer

	  LDX	    ,U++
	  BSR	    BFINIT		;monitor buffer
	  BSR	    ININIT		;command buffer

	  LDD	    TTI_NM		;correct data buffer C-Q counter
	  SUBD	    #256
	  STD	    TTI_NM

	  PULU	    B,X
	  TFR	    U,Y
	  LBSR	    BLTRN		;dispatch table
	  TFR	    Y,U

	  PULU	    B,X			;my stuff
	  BSR	    CLEAR
	  PULU	    B,X			;hi-level stuff
	  BSR	    CLEAR
	  PULU	    B,X			;hi-level MON stuff
	  BSR	    CLEAR

	  CLR	    LIN_FL		;line-typed flag

	  PULU	    X,Y			;init beacon text string
	  LDB	    >BTLEN
	  CLRA
	  STD	    BECLEN
	  LBSR	    BLTRN
	  INC	    QSO_FL		;set non-transparent flag

	  LBSR	    DECNOV
	  LDX	    TTI_US		;hi level pointer
	  STX	    AIRP

	  LDB	    SCR_WD+1		;init counters for packet & screen
	  STB	    SCR_CT
	  LDB	    PKT_LN+1
	  STB	    PKT_CT

	  LBSR	    SINIT
	  LBSR	    PINIT
	  LBSR	    VINIT		;start timers & HDLC
	  LBSR	    HINIT
	  CLR	    INTRPT
	  LDB	    #(TTI+TTO+TIM+PAK)
	  LBSR	    SETINT

; Enter command mode

	  TST	    >DEF_FL
	  BEQ	    RSET_a		;skip for non-default start
	  LBSR	    AUTOBD

	  LBSR	    CMINIT
	  LDY	    #MSG1		;this message for default params
	  LDD	    #MG1LEN
	  BRA	    RSET_4

RSET_a	  LBSR	    CMINIT
	  LDY	    #MSG2		;this message usually
	  LDD	    #MG2LEN
RSET_4	  LBSR	    WRITE

	  COMN
RAMMSG	  ASC	    "RAM length is "
RMSLEN	  EQU	    ($-RAMMSG)
HIRMSG	  ASC	    "High RAM length is "
HIRLEN	  EQU	    ($-HIRMSG)

	  PROG
	  LDY	    #RAMMSG		;report RAM length from test
	  LDD	    #RMSLEN
	  LBSR	    WRITE
	  LDD	    >RAMTOP
	  LBSR	    WRTHEX
	  LBSR	    WRITECR

	  LDD	    >HITOP		;report high RAM if present
	  SUBD	    >HIBOT
	  BEQ	    NOHIGH
	  PSHS	    D
	  LDY	    #HIRMSG
	  LDD	    #HIRLEN
	  LBSR	    WRITE
	  PULS	    D
	  LBSR	    WRTHEX
	  LBSR	    WRITECR

NOHIGH	  LDA	    ERR_FL
	  RORA
	  BCC	    RSET_3
	  PSHS	    A
	  LDY	    #HDMSG		;write no-HDLC message
	  LDD	    #HDLEN
	  LBSR	    WRITE
	  PULS	    A

RSET_3	  RORA
	  BCC	    RSET_6
	  PSHS	    A
	  LDY	    #PMSG		;no-PIA message
	  LDD	    #PLEN
	  LBSR	    WRITE
	  PULS	    A

RSET_6	  RORA
	  BCC	    RSET_5
	  PSHS	    A
	  LDY	    #VMSG		;no-VIA message
	  LDD	    #VLEN
	  LBSR	    WRITE
	  PULS	    A

RSET_5
	  IF	    Parallel		;conditional

	  RORA
	  BCC	    RSET_7
	  LDY	    #SMSG		;no-SIA message
	  LDD	    #SLEN
	  LBSR	    WRITE

	  ENDIF				;parallel

RSET_7	  LDY	    #PROMPT		;ready to roll
	  LDD	    #PROLEN
	  LDU	    #PRO_CT+3
	  PSHU	    B,Y
	  LBSR	    WRITE

	  EXTERNAL  AX25
COMAND_   LBRA	    AX25

	  COMN
MSG1	  FCB	    CR
	  ASC	    "Tucson Amateur Packet Radio Corporation"
	  FCB	    CR
	  IF	    Beta
	  ASC	    "TAPR/AMSAT AX.25 level 2 version Beta 3.2"
	  ELSE
	  ASC	    "TAPR/AMSAT AX.25 level 2 version 3.2"
	  ENDIF
	  FCB	    CR
MG1LEN	  EQU	    ($-MSG1)

MSG2	  FCB	    CR
	  ASC	    "TAPR packet radio"
	  FCB	    CR
MG2LEN	  EQU	    ($-MSG2)

HDMSG	  ASC	    "*** HDLC can't init"
	  FCB	    CR
HDLEN	  EQU	    ($-HDMSG)

PMSG	  ASC	    "*** parallel port can't init"
	  FCB	    CR
PLEN	  EQU	    ($-PMSG)

VMSG	  ASC	    "*** VIA can't init"
	  FCB	    CR
VLEN	  EQU	    ($-VMSG)

SMSG	  ASC	    "*** UART can't init"
	  FCB	    CR
SLEN	  EQU	    ($-SMSG)

FAILMS	  ASC	    "*** too many packets pending"
	  FCB	    CR
FAILNM	  EQU	    ($-FAILMS)

	  PROG
CMDBEG	  SEI				;here from command interrupt
	  TST	    DIA_FL
	  BNE	    CBEG_0

	  LDA	    #(.NT.CMD)
	  LBSR	    CLRBIT

CBEG_0	  CLR	    CTO_FL
	  CLR	    BSY_FL		;clear GETCHR
	  BSR	    CMINIT
	  TST	    CTS_FL		;undo auto-flow
	  BGE	    CBEG_1
	  CLR	    CTS_FL
CBEG_1	  LDY	    #PROMPT		;write command prompt
	  LDD	    #PROLEN
	  CLI
	  LBSR	    WRITE
	  RTI

CMINIT	  DEC	    DBG_FL		;set flag
	  INC	    COM_FL
	  LDB	    #INLEN
	  LDY	    #INLIST		;save flags & pointers in
	  LDX	    #SCILST		;scratch area
	  LBSR	    BLTRN
	  LDB	    #INLEN		;transfer command flags &
	  LDY	    #CMLIST		;pointers to I/O area
	  LDX	    #INLIST
	  LBSR	    BLTRN
	  CLI				;enable interrupts
	  RTS

	  TITLE     "Init and dispatch -- TNC LLR, Margaret Morrison"
; Init VIA for clocks, start HDLC

	  COMN
VIADAT	  FCB	    T12MOD		;A  VIA data
	  FCB	    VINTDS		;B  disable interrupts
	  FCB	    IOPAGE		;DP
	  FDB	    T2DAT		;X

	  PROG
	  SETDP     IOPAGE
VINIT	  CLRA
	  PSHS	    CC,A,DP,U
	  LDU	    #VIADAT
	  SEI
	  PULU	    A,B,DP,X
	  STA	    AUXCR		;set timer modes
	  CMPA	    AUXCR
	  BEQ	    VINI_1
	  INC	    1,S

VINI_1	  STB	    IER
	  BITB	    IER			;read back all that are not enabled
	  BEQ	    VINI_2
	  INC	    1,S

VINI_2	  STX	    TIM2		;start timer 2
	  NOP
	  CMPX	    TIM2		;make sure timer running
	  BNE	    VINI_3
	  INC	    1,S

	  SETDP     PAGE
VINI_3	  PULS	    CC,A,DP,U
	  TSTA
	  BEQ	    VINI_4

VBAD	  LDA	    ERR_FL
	  ORA	    #NOVIA		;set failure flag
	  STA	    ERR_FL
VINI_4	  LDB	    #TIM
	  LBSR	    INTON		;page ok
	  RTS

	  COMN
HDLDAT	  FCB	    HRESET		;A  HDLC data
	  FCB	    HOPER		;B
	  FCB	    IOPAGE		;DP

	  FCB	    CR3DAT		;A
	  FCB	    HDPAGE		;DP
	  FCB	    CR2DAT		;Xh (A)
	  FCB	    0FFH		;Xl (B) interrupts off

	  PROG

HINIT	  CLRA				;6522 flag
	  CLRB				;HDLC flag
	  PSHS	    CC,A,B,DP,U
	  LDX	    RFBAUD
	  LDU	    #HDLDAT
	  SEI

	  SETDP     IOPAGE
	  PULU	    A,B,DP
	  STX	    TIM1		;start timer 1
	  STA	    PERCR		;reset HDLC
	  CMPA	    PERCR
	  BEQ	    HINI_1
	  INC	    1,S			;VIA bad

HINI_1	  CLRA
HINI_2	  DECA
	  BNE	    HINI_2
	  STB	    PERCR		;clear reset of HDLC
	  CMPB	    PERCR
	  BEQ	    HINI_3
	  INC	    1,S

HINI_3	  DECA				;wait again
	  BNE	    HINI_3

	  SETDP     HDPAGE
	  PULU	    A,DP,X
	  STA	    CR3			;load control registers
	  CMPA	    CR3
	  BEQ	    HINI_4
	  INC	    2,S

HINI_4	  TFR	    X,D
	  STA	    CR2
	  CMPA	    CR2
	  BEQ	    HINI_5
	  INC	    2,S

HINI_5	  STB	    CR1
	  CMPB	    CR1
	  BEQ	    HINI_6
	  INC	    2,S

HINI_6	  LDA	    IR
	  LDA	    SR
	  LDA	    RHR
	  PULS	    CC,A,B,DP,U

	  SETDP     PAGE
	  TSTA
	  BEQ	    HINI_7
HVBAD	  LDA	    ERR_FL		;VIA failure
	  ORA	    #NOVIA
	  STA	    ERR_FL
HINI_7	  TSTB
	  BEQ	    HINI_8
HBAD	  LDB	    ERR_FL		;1933 failure
	  ORB	    #NOHDLC
	  STB	    ERR_FL
HINI_8	  LDB	    #PAK
	  LBSR	    INTON		;page ok
	  RTS

; disable HDLC and timer interrupts

	  COMN
PIADAT	  FCB	    SETDDR		;1st CRA/CRB data
	  FCB	    PIAOUT		;DDRA/DDRB data
	  FCB	    IOPAGE
	  FCB	    SETDAT		;2nd CRA/CRB data
	  FCB	    SETDAT

	  IF	    Parallel		;conditional

PTMDAT	  FCB	    SETDDR		;1st CRA/CRB data
	  FCB	    PIAIN		;input mode for A
	  FCB	    IOPAGE
	  FCB	    PIAOUT		;output mode for B
	  FCB	    HSKDAT		;handshake mode data
	  FCB	    HSKDAT

; This routine sets up parallel port for terminal I/O
; Enable interrupts on low-to high transition of Cx1
; Pulse output of Cx2 on read/write

	  PROG
	  SETDP     IOPAGE
PTERM	  LDU	    #PTMDAT
	  SEI
	  PULU	    A,B,DP,X
	  STA	    CRA			;set direction A
	  STB	    PDDRA
	  CMPB	    PDDRA
	  BNE	    PTBAD

	  PULU	    B
	  STA	    CRB			;set direction B
	  STB	    PDDRB
	  CMPB	    PDDRB
	  BNE	    PTBAD

	  PULU	    A,B
	  STA	    CRA			;set handshake mode
	  EORA	    CRA
	  ANDA	    #3FH
	  BNE	    PTBAD

	  STB	    CRB			;set handshake mode
	  EORB	    CRB
	  ANDB	    #3FH
	  BNE	    PTBAD		;make sure one bit set

	  PULS	    CC,DP,U,PC		;init parallel port for all output

PTBAD	  LDA	    PERCR		;blink lights for signal
	  EORA	    #22H
	  STA	    PERCR
	  LBRA	    RESET

	  ENDIF				;parallel

; This routine sets up the parallel port for 16 output pins with
; no interrupts and no handshaking

	  PROG
	  SETDP     IOPAGE
PINIT	  PSHS	    CC,DP,U		;init parallel port for all output

	  IF	    Parallel		;conditional

	  TST	    >ABAUD+1
	  BEQ	    PTERM

	  ENDIF				;parallel

	  LDU	    #PIADAT
	  SEI
	  PULU	    A,B,DP
	  CLR	    ,-S			;make space for error flag

	  STA	    CRA			;set data direction registers
	  STB	    PDDRA
	  CMPB	    PDDRA
	  BEQ	    PINI_1
	  INC	    ,S

PINI_1	  STA	    CRB
	  STB	    PDDRB
	  CMPB	    PDDRB
	  BEQ	    PINI_2
	  INC	    ,S

PINI_2	  PULU	    A,B			;set data to outputs
	  STA	    CRA
	  EORA	    CRA			;make sure write bits match
	  ANDA	    #3FH
	  BEQ	    PINI_3		;make sure one bit set
	  INC	    ,S

PINI_3	  STB	    CRB
	  EORB	    CRB
	  ANDB	    #3FH
	  BEQ	    PINI_4
	  INC	    ,S

PINI_4	  CLRA
	  STA	    PIA
	  STA	    PIB
	  LDA	    ,S+
	  BEQ	    PINI_5
PBAD	  LDB	    >ERR_FL
	  ORB	    #NOPIA		;set error flag
	  STB	    >ERR_FL
PINI_5	  PULS	    CC,DP,U,PC

; Autobaud routine for default parameter start-up

	  SETDP     PAGE
AUTOBD	  LDX	    TTI_IV		;save regular vector

	  IF	    Parallel		;conditional

	  LDY	    PRL_IV

	  ENDIF				;parallel

	  PSHS	    DP,X,Y
	  LDX	    #AUTOI1		;set special vector
	  STX	    TTI_IV

	  IF	    Parallel		;conditional

	  LDX	    #AUTOPL		;set vector for port B interrupts
	  STX	    PRL_IV

	  ENDIF				;parallel

	  INC	    ABD_FL		;set flag
	  INC	    DIA_FL		;disable diagnostices
	  LDB	    #(TTI+TTO)		;turn off clock & HDLC
	  LBSR	    SETINT

	  IF	    Parallel		;conditional

	  PSHS	    DP

	  SETDP     IOPAGE
	  LDA	    #IOPAGE
	  TFR	    A,DP
	  CLR	    CRA
	  CLR	    PDDRA
	  LDA	    #HSKDAT		;enable input pp
	  STA	    CRA

	  SETDP     PAGE
	  PULS	    DP

	  ENDIF				;parallel

	  CLI
	  LDY	    #AUTOMS		;type <cr> message
	  LDD	    #AUTOLN
	  LBSR	    WRITE

AUTO_1	  TST	    TYP_FL		;wait for message
	  BNE	    AUTO_1

	  SEI
	  LDX	    #AUTOI2		;move to autobaud routine
	  STX	    TTI_IV

	  IF	    Parallel		;conditional

	  LDA	    #4			;disable port B
	  STA	    >CRB

	  ENDIF				;parallel

	  LDY	    #WAITLS
	  LDX	    #BAUDLS		;get autobaud list
	  LDB	    #BAUDCT
AUTO_2	  LDA	    ,X+			;6 get next baud rate
	  BSR	    TRYNXT		;3 try it
	  DECB				;2
	  BNE	    AUTO_2		;3
	  LBRA	    RESET		;give up

	  IF	    Parallel		;conditional

; Receive confirm from printer

	  SETDP     IOPAGE
AUTOPL	  CMPA	    #"*"		;test received *
	  BNE	    AUTOI0
	  LDA	    #HSKDAT		;enable port B
	  STA	    CRB
	  CLR	    SCMND		;disable serial port
	  LEAS	    12,S		;clean up stack

	  SETDP     PAGE
	  PULS	    DP,X,Y
	  CLR	    ABAUD+1		;set flag
	  BRA	    ATIV_4		;exit

	  ENDIF				;parallel

; Typein during output at 300 baud

	  SETDP     IOPAGE
AUTOI1	  CMPA	    #"*"		;got * -- ok
	  BEQ	    ATIV_1
AUTOI0	  RTI				;do-nothing interrupt

ATIV_1	  LEAS	    12,S		;clean up stack
ATIV_2
	  IF	    Parallel		;conditional

	  CLR	    CRA			;turn off port A & set to output
	  LDA	    #0FFH
	  STA	    PDDRA
	  LDA	    #4
	  STA	    CRA

	  ENDIF				;parallel

	  LDA	    SCNTRL		;save baud rate

	  SETDP     PAGE
	  PULS	    DP,X,Y
	  CLR	    DIA_FL		;enable diagnostics
	  STA	    TTBAUD		;store baud rate
	  ANDA	    #0FH
	  STA	    ABAUD+1
	  LDB	    #(TTI+TTO+TIM+PAK)	;re-enable interrupts
	  LBSR	    SETINT

ATIV_4	  STX	    TTI_IV		;restore vector

	  IF	    Parallel		;conditional

	  STY	    PRL_IV

	  ENDIF				;parallel

	  CLR	    ABD_FL
	  LBSR	    PUTNV		;write new status
	  RTS				;return from AUTOBD

	  SETDP     IOPAGE
TRYNXT	  PSHS	    A,B,DP,X		;10 save data, count
	  LDB	    #IOPAGE		;2
	  TFR	    B,DP		;6
	  LDB	    SCMND		;4 save command register
	  PSHS	    B			;6
	  STA	    SRESET		;4 reset 6551

	  LDD	    ,Y++		;8 get wait time
TRYN_1	  DECB				;2
	  BNE	    TRYN_1		;3
	  TSTA				;2
	  BNE	    TRYN_a		;3
	  DECA				;2
	  BRA	    TRYN_1		;3

TRYN_a	  PULS	    A,B			;7
	  STB	    SCNTRL		;4 init 6551
	  STA	    SCMND		;4

TRYN_2	  CWAI	    #0EFH		;20 wait
	  BRA	    TRYN_2		;3

AUTOI2	  CMPA	    #"*"		;2 test *
	  BNE	    ATIV_3		;3
	  LEAS	    18,S		;5 done
	  BRA	    ATIV_2		;3 return

ATIV_3	  LEAS	    6,S			;5
	  PULS	    Y,U			;9
	  LEAS	    2,S			;5 clean up stack
	  PULS	    B,DP,X,PC		;11 return from TRYNXT

	  COMN
AUTOMS	  ASC	    "Please type a star ( * ) for autobaud routine"
	  FCB	    CR,0
AUTOLN	  EQU	    ($-AUTOMS)
;		     96  48  12 300 110
BAUDLS	  FCB	    3EH,3CH,38H,36H,33H
BAUDCT	  EQU	    ($-BAUDLS)
WAITLS	  FDB	    3080,58,250,1363,4459

; Initialize 6551

	  SETDP     IOPAGE
SINIT	  PSHS	    CC,DP
	  LDB	    #IOPAGE
	  TFR	    B,DP

	  IF	    Parallel		;conditional

	  TST	    >ABAUD+1
	  BEQ	    SINIT0

	  ENDIF				;parallel

	  SEI
	  LDA	    #100
	  STA	    SRESET
SINI_1	  DECA
	  BNE	    SINI_1

	  LDA	    >RONTOF		;set up for Rx on, Tx off
	  LDB	    >TTBAUD

	  STB	    SCNTRL		;init uart
	  CMPB	    SCNTRL
	  BNE	    SBAD
	  STA	    SCMND
	  CMPA	    SCMND
	  BNE	    SBAD
	  LDA	    RDR			;clear RDR
	  PULS	    CC,DP,PC

SBAD	  LDA	    PERCR		;blink lights for signal
	  STA	    SRESET
	  EORA	    #22H
	  STA	    PERCR
	  LBRA	    RESET

	  IF	    Parallel		;conditional

SINIT0	  LDA	    #1
	  STA	    >DIA_FL		;don't send junk to PP
	  LDD	    #30H		;init to read dcd
	  STA	    SCMND
	  CMPA	    SCMND
	  BEQ	    SINI_2
	  INCB

SINI_2	  LDA	    SSTAT
	  CLR	    >BUS_FL
	  BITA	    #BSY		;init busy line
	  BEQ	    SINI_3
	  INC	    >BUS_FL

SINI_3	  TSTB
	  BEQ	    SINI_4
	  LDB	    >ERR_FL
	  ORB	    #NOSIA		;set error flag
	  STB	    >ERR_FL

SINI_4	  PULS	    CC,DP,PC

	  ENDIF				;parallel

; Selectively enable and disable interrupts
; Call with desired mask in B

	  SETDP     PAGE
SETINT	  PSHS	    CC,A,B,DP		;new mask on stack
	  LDA	    #PAGE		;make sure page is right
	  TFR	    A,DP
	  SEI
	  EORB	    INTRPT		;find changing bits
	  PSHS	    B			;save change mask
	  ANDB	    INTRPT		;now have disable mask
	  BSR	    INTOFF

	  PULS	    B			;get change mask
	  ANDB	    2,S			;match with new mask
					; for enable bits
	  BSR	    INTON
	  PULS	    CC,A,B,DP,PC

; INTOFF and INTON require PAGE in DP on entry.
; Disable interrupts flagged 1 in mask (B)

	  SETDP     IOPAGE
INTOFF	  PSHS	    CC,A,DP
	  SEI
	  LDA	    #IOPAGE
	  TFR	    A,DP

	  IF	    Parallel		;conditional

	  TST	    >ABAUD+1
	  BNE	    IOFF_a
	  LDA	    #HSKDIS		;disable interrupts for parallel port
	  BITB	    #TTI
	  BEQ	    IOFF_b
	  STA	    CRA

IOFF_b	  BITB	    #TTO
	  BEQ	    IOFF_c
	  STA	    CRB
	  BRA	    IOFF_c

	  ENDIF				;parallel

IOFF_a	  LDA	    SCMND
	  BITB	    #TTI		;terminal input
	  BEQ	    IOFF_1
;	  ANDA	    #0FCH		;keep top 3/4 of command
	  ORA	    #(DTR.OR.REN_)	;tty input off

IOFF_1	  BITB	    #TTO
	  BEQ	    IOFF_2
	  ANDA	    #0F3H		;keep input part
	  ORA	    #REC		;output interrupts off
IOFF_2	  STA	    SCMND

IOFF_c	  BITB	    #TIM
	  BEQ	    IOFF_3
	  LDA	    #VINTDS		;timer off
	  STA	    IER

IOFF_3	  BITB	    #PAK
	  BEQ	    IOFF_4
	  LDA	    #0FFH		;HDLC off
	  STA	    >CR1

	  SETDP     PAGE
IOFF_4	  PULS	    CC,A,DP
	  COMB
	  ANDB	    INTRPT		;toggle masked bits
	  STB	    INTRPT
	  RTS

; Enable bits masked by 1

	  SETDP     IOPAGE
INTON	  PSHS	    CC,A,DP
	  SEI
	  LDA	    #IOPAGE
	  TFR	    A,DP

	  IF	    Parallel		;conditional

	  TST	    >ABAUD+1
	  BNE	    ION_a
	  LDA	    #HSKDAT		;enable interrupts for parallel port
	  BITB	    #TTI
	  BEQ	    ION_b
	  STA	    CRA

ION_b	  BITB	    #TTO
	  BEQ	    ION_c
	  STA	    CRB
	  BRA	    ION_c

	  ENDIF				;parallel

ION_a	  LDA	    SCMND
	  BITB	    #TTI		;terminal input
	  BEQ	    ION_1
	  ANDA	    #0FCH		;keep top 3/4 of command
	  ORA	    #DTR		;tty input on

ION_1	  BITB	    #TTO
	  BEQ	    ION_2
	  ANDA	    #0F3H		;keep input part
	  ORA	    #TRX		;output interrupts on
ION_2	  STA	    SCMND

ION_c	  BITB	    #TIM
	  BEQ	    ION_3
	  LDA	    #T2ENAB		;enable timer
	  STA	    IER

ION_3	  BITB	    #PAK
	  BEQ	    ION_4
	  LDA	    #RCVR		;HDLC receiver on
	  STA	    >CR1

	  SETDP     PAGE
ION_4	  PULS	    CC,A,DP
	  ORB	    INTRPT
	  STB	    INTRPT
	  RTS

; Interrupt dispatcher.
; TST_WD allows check for spurious interrupt on power-on.
; Pass to interrupt routine with B containing PAGE and DP containing
;   IOPAGE.
; For terminal input, register is read here

	  PROG
DISPAT	  LDX	    >TST_WD		;6 test ram init
	  CMPX	    #TEST		;4
	  LBNE	    RESET		;5

	  SETDP     IOPAGE
	  LDD	    #(IOPAGE*100H+1)	;3
	  TFR	    A,DP		;6

	  TST	    >ABD_FL		;7 select right dispatcher
	  LBNE	    ADISPT		;6 autobaud in progress

	  IF	    Parallel		;conditional

	  TST	    >ABAUD+1
	  BEQ	    PARDIS		;parallel port enabled

	  ENDIF				;parallel

; here for serial I/O, normal mode

SDISPT	  LDA	    SSTAT		;test receive
	  BPL	    CDISPT
	  BITA	    #RDF
	  BEQ	    TDISPT

; receive register

	  LDA	    RDR			;normal input
	  BSR	    DIAGNS
	  JMP	    [TTI_IV]

; transmit register

TDISPT	  BITA	    #TDE		;test transmit
	  BNE	    TDIS_1
	  RTI

TDIS_1	  LSLB
	  BSR	    DIAGNS
	  JMP	    [TTO_IV]

; timer

CDISPT	  LDB	    #4			;test timer
	  LDA	    IFR
	  BPL	    HDISPT
	  BITA	    #T2MASK
	  BNE	    CDIS_1
	  RTI

CDIS_1	  BSR	    DIAGNS
	  JMP	    [CLK_IV]

; packets

HDISPT	  LDA	    >IR			;test hdlc
	  COMA
	  BITA	    #7
	  BEQ	    XDISPT
	  LDB	    >SR			;save status
	  COMB
	  STD	    >STATUS
	  TFR	    A,B
	  ANDB	    #0F8H
	  BSR	    DIAGNS
	  JMP	    [PKT_IV]

XDISPT	  RTI				;false alarm

DIAGNS	  TST	    >DIA_FL		;write pp signals
	  BNE	    DIAG_1
	  EORB	    PIB
	  STB	    PIB
DIAG_1	  LDB	    #PAGE
	  RTS

	  IF	    Parallel		;conditional

; parallel I/O, normal mode

PARDIS	  LDB	    #PAGE
	  LDA	    IFR			;test timer
	  BPL	    PPDISP
	  BITA	    #T2MASK
	  BEQ	    PARD_1
	  JMP	    [CLK_IV]
PARD_1	  RTI

PPDISP	  LDA	    >IR			;test hdlc
	  COMA
	  BITA	    #7
	  BEQ	    PBDISP
	  LDB	    >SR
	  COMB
	  STD	    >STATUS
	  LDB	    #PAGE
	  JMP	    [PKT_IV]

;parallel port: output then input

PBDISP	  TST	    CRB			;test port B
	  BPL	    PBDS_3
	  LDA	    SSTAT
PBDS_1	  BITA	    #BSY		;test busy line
	  BNE	    PBDS_2
	  CLR	    SCMND
	  JMP	    [TTO_IV]

PBDS_2	  LDA	    #3			;set interrupt when busy drops
	  STA	    SCMND
	  RTI

PBDS_3	  LDA	    SSTAT		;test for busy-drop interrupt
	  BMI	    PBDS_1

PADISP	  TST	    CRA			;test port A
	  BPL	    PADS_1
	  JMP	    [TTI_IV]
PADS_1	  RTI

	  ENDIF				;parallel

; first autobaud interrupt

ADISPT	  LDB	    #PAGE		;2
	  LDA	    SSTAT		;4 check serial input
	  BPL	    CADIS1		;3
	  BITA	    #RDF		;2 receive register
	  BEQ	    TDS1_1		;3
	  LDA	    RDR			;4
	  JMP	    [TTI_IV]		;8

TDS1_1	  BITA	    #TDE		;transmit as usual
	  BEQ	    TDS1_2
	  JMP	    [TTO_IV]

TDS1_2
	  IF	    Parallel		;conditional

	  BITA	    #BSY		;send another <cr> to port B
	  BNE	    TDS1_3		; if busy drops
	  LDA	    #CR
	  STA	    PIB

	  ENDIF				;parallel

TDS1_3	  RTI

CADIS1	  LDA	    IFR			;normal timer interrupt
	  BPL	    HADIS1
	  BITA	    #T2MASK
	  BEQ	    CADS_1
	  JMP	    [CLK_IV]
CADS_1	  RTI

HADIS1	  LDA	    >IR			;normal packet interrupt
	  COMA
	  BITA	    #7
	  BEQ	    PLDISP
	  LDB	    >SR
	  COMB
	  STD	    >STATUS
	  LDB	    #PAGE
	  JMP	    [PKT_IV]

PLDISP
	  IF	    Parallel		;conditional

	  TST	    CRA			;test output pp interrupts
	  BPL	    XADIS1
	  LDA	    PIA
	  JMP	    [PRL_IV]

	  ENDIF				;parallel

DISMIS	  LDA	    CRA			;dummy to clear parallel port
	  LDA	    CRB
XADIS1	  RTI				;false alarm

	  TITLE     "Timer interrupts -- TNC LLR, Margaret Morrison"
; Timer 2 interrupt servicer

	  PROG
	  SETDP     IOPAGE
TIMOUT	  PSHS	    B			;  save PAGE
	  LDD	    TIM2		;6 get interval since timeout
	  DECA				;1 correct for different read time
	  ADDA	    #T2DATA		;2 correct data
	  ADCB	    #T2DATB		;2
	  STD	    TIM2		;6 restart clock

	  SETDP     PAGE
	  PULS	    DP
	  LDB	    #NCLOK		;increment all timers
	  LDY	    #CLOCK
TIMO_1	  LDX	    ,Y			;increment loop
	  LEAX	    1,X
	  STX	    ,Y++
	  DECB
	  BNE	    TIMO_1

	  LDA	    CL_CLK+1
	  CMPA	    #100
	  BNE	    TIMO_2		;update 1-sec clocks
	  INC16     ID_CLK
	  INC16     HI_CLK
	  CLR	    CL_CLK+1

TIMO_2	  TST	    IDG_FL
	  BLT	    IDSTRT		;time to start CW id
	  BEQ	    TIMO_3

	  DEC	    ELM_CT		;CW id in progress
	  LBEQ	    CWNEXT		;do next element
	  BRA	    TIMO_5

TIMO_3	  LDX	    ID_CLK		;check time
	  CMPX	    #IDTIME
	  BLT	    TIMO_4
	  TST	    AID_FL		;test auto ID
	  BEQ	    NOTNOW
	  TST	    KEY_FL
	  BLE	    NOTNOW
	  DEC	    IDG_FL		;set flag

IDSTRT	  TST	    TOK_FL
	  BLT	    TIMO_5
	  BSR	    CWBEGN
	  RTI

NOTNOW	  CLR16     ID_CLK		;reset clock
	  LDA	    #0FFH		;set no transmission since ID
	  STA	    KEY_FL

TIMO_4	  TST	    PKT_ST
	  BNE	    TIMO_5
	  TST	    DLY_FL		;already set
	  BNE	    TIMO_5
	  LDX	    >SQL_TM		;check repeater squelch tail
	  CMPX	    CS_CLK
	  BGT	    TIMO_5
	  INC	    DLY_FL		;set flag for repeater drop

TIMO_5	  LDB	    TRN_FL
	  LBNE	    TRNTIM
	  TST	    CPT_FL		;opaque mode packet timeout
	  BEQ	    TXMTIM
	  TST	    DBG_FL		;only in converse mode
	  BNE	    TXMTIM
	  LDX	    >PAC_TM
	  BEQ	    TXMTIM
	  LDD	    TTI_IN		;no zero-length forced packets
	  CMPD	    TTI_PK
	  BEQ	    TIMO_6
	  CMPX	    TN_CLK
	  BGT	    TXMTIM
	  LDA	    C_CTLP		;put packet character in buffer
	  LBRA	    GOTCHR

TIMO_6	  CLR16     TN_CLK
TXMTIM	  LDA	    TOK_FL
	  BGE	    TXMT_1
	  RTI				;no transmission if -1

TXMT_1	  DECA
	  BLT	    TXMOK		;ok if 0
	  BGT	    DPTOK

	  LDD	    CS_CLK		;here for flag = 1
	  SUBD	    >DWT_TM
	  CMPD	    RAN_TM
	  BGE	    TXMT_2

FRSTOK	  TST	    RTY_FL		;ok for first try (not retry)
	  BEQ	    TXMOK
	  RTI

TXMT_2	  CLR	    TOK_FL		;random time expired
TXMOK	  TST	    PKW_FL		;first check to send packet
	  BEQ	    TXMT_4
	  LBSR	    STTPKT
TXMT_4	  RTI

DPTOK	  LDD	    CS_CLK
	  CMPD	    >DWT_TM
	  BLT	    TXMT_3
	  DEC	    TOK_FL		;now ok to send first try
	  BRA	    FRSTOK

TXMT_3	  TST	    DIG_FL		;ok to transmit digipeat
	  BNE	    TXMOK
	  RTI

	  TITLE     "Morse Code ID Routine -- LLR, Margaret Morrison"
; CW id sending routine

	  COMN
CWTAB	  FCB	    0,1EH,52H,2AH,45H,0,0,5EH,36H,6DH,6BH,31H,73H,61H,55H,32H
;		       !   "  #ar $sk % &  '   (   )  *kw +bt  ,   -   .   /
	  FCB	    3FH,2FH,27H,23H,21H,20H,30H,38H,3CH,3EH,78H,6AH,0,0,0,4CH
;		     0	 1   2	 3   4	 5   6	 7   8	 9   :	 ;  < = >  ?
	  FCB	    31H,05H,18H,1AH,0CH,02H,12H,0EH,10H,04H,17H,0DH,14H,07H,06H,0FH
;		    @bt  A   B	 C   D	 E   F	 G   H	 I   J	 K   L	 M   N	 O
	  FCB	    16H,1DH,0AH,08H,03H,09H,11H,0BH,19H,1BH,1CH
;		     P	 Q   R	 S   T	 U   V	 W   X	 Y   Z
CWMAX	  EQU	    ($-CWTAB)

	  PROG

; ID initialization (subroutine called from TIMOUT)

CWBEGN	  LDA	    #TXMOUT		;key transmitter
	  EORA	    TXM_FL
	  STA	    >CR1

	  LDY	    #CWTAB
	  LDX	    #IDTXT		;get id string
	  LDB	    IDLEN+1
	  BEQ	    CWBG_1		;use address ID

	  LDA	    ,X			;test valid start character
	  LBSR	    TSTCHR
	  TSTA
	  BNE	    CWBG_2
	  CLR	    IDLEN+1		;zero out length

CWBG_1	  LDB	    #6
	  LDX	    #CALSIN		;get lookup addresses
CWBG_2	  STB	    IDS_CT

	  LDU	    #USTK5
	  CLRA				;go away & wait for keyup
	  CLRB
	  PSHU	    D,X,Y		;set up parameters

	  LDD	    #1FFH		;start CW id
	  STA	    IDG_FL
	  STB	    KEY_FL		;set ID status
	  TST	    TOK_FL
	  BNE	    CWBG_3

; not previously transmitting -- set tone immediately

	  DEC	    TOK_FL		;ID mode
	  BSR	    CWTONE		;set tone correctly
	  LDB	    >TXM_TM+1		;key transmitter and wait
	  STB	    ELM_CT
	  RTS

; previously sending packet -- wait for flags to stop
CWBG_3	  STA	    >TON_FL		;wait to set tone
	  STB	    TOK_FL		;switch to ID mode
	  LDB	    #18
	  STB	    ELM_CT
	  RTS

; This routine sets correct tone for ID mark (low)

CWTONE	  CLR	    MRKTON
	  LDA	    >SR
	  COMA				;opposite value  **
	  ANDA	    #MISCIN		;test tone state
	  LSLA
	  PSHS	    A
	  LDA	    >PERCR
	  ANDA	    #(.NT.CB2)		;set CB2 opposite to TxD
	  ORA	    ,S+
	  STA	    >PERCR
	  CLR	    >TON_FL
	  LDA	    #18			;wait one space at beginning
	  STA	    ELM_CT
	  RTS

; Continue sending ID (branch from DISPAT)

CWNEXT	  TST	    >TON_FL		;see if tone set previously
	  BEQ	    CWNX_1
	  BSR	    CWTONE
	  RTI

CWNX_1	  LDU	    #USTK4
	  PULU	    A,B
	  TST	    MRKTON		;test if now sending mark or space
	  BEQ	    CWBITS
	  BSR	    SPACON		;here for end of tone
	  LDA	    #6			;inter-element space
	  TSTB
	  BNE	    CWNX_2		;finished last element
	  LDA	    #18
CWNX_2	  STA	    ELM_CT		;inter-letter space
	  RTI

SPACON	  CLR	    MRKTON		;clear CB2
	  BRA	    MARK_1

MARKON	  INC	    MRKTON
MARK_1	  LDA	    >PERCR		;set CB2
	  EORA	    #20H
	  STA	    >PERCR
	  RTS

CWBITS	  DECB
	  BLT	    LTRDON
	  ROLA
	  PSHU	    A,B			;save code, counter
	  BCC	    CWBT_1
	  LDA	    #18
	  BRA	    CWBT_2
CWBT_1	  LDA	    #6			;count for length of element
CWBT_2	  STA	    ELM_CT
	  BSR	    MARKON		;make tone
	  RTI

TSTCHR	  CMPA	    #60H
	  BLT	    TSTC_1
	  ANDA	    #5FH		;upper case only
TSTC_1	  SUBA	    #20H		;adjust for table
	  BLE	    TSTC_2		;skip funny characters
	  CMPA	    #CWMAX
	  BGE	    TSTC_2
	  LDA	    A,Y			;get CW code
	  RTS

TSTC_2	  CLRA
	  RTS

LTRDON	  PULU	    X,Y			;get next character
NEXTCH	  DEC	    IDS_CT		;test done
	  BLT	    CWEXIT
	  LDA	    ,X+			;next character
	  CMPA	    #20H
	  BEQ	    LTRSPC
	  BSR	    TSTCHR
	  TSTA
	  BEQ	    NEXTCH
	  LDB	    #7			;init counter
	  PSHU	    X,Y			;save pointer

	  CLC
NEXT_1	  ROLA				;find first set bit
	  BCS	    CWBITS
	  DECB
	  BNE	    NEXT_1
	  BRA	    NEXTCH		;no set bits

LTRSPC	  DEC	    IDS_CT		;ignore at end of text
	  BLT	    CWEXIT
	  LDA	    ,X+			;skip multiple spaces
	  BSR	    TSTCHR
	  TSTA
	  BEQ	    LTRSPC

	  INC	    IDS_CT		;restore count -- valid character
	  LEAX	    -1,X
	  PSHU	    X,Y			;save pointer
	  LDA	    #24			;leave letter space
	  STA	    ELM_CT
	  RTI

CWEXIT	  LBSR	    PKRES		;turn off transmitter
	  STD	    ID_CLK		;reset clock
	  STA	    IDG_FL		;reset flag
	  BSR	    SPACON
	  RTI

	  TITLE     "Transparent Mode Timing -- LLR, Margaret Morrison"
; Transparent-mode flags

; TRN_FL  0  not transparent mode
;	  1  accepting data, waiting for timeout to send packet
;	  2  escape guard time
;	  3  waiting for control-Cs
;	  4  second escape guard time
;	  5  waiting to access
;	  6  waiting to send last packets

; PAC_FL -1  all packets must wait for fence to clear
;	  0  even packets in buffer, add anything
;	  1  timeout occured, waiting for fence to clear

	  COMN
TRNTAB	  FDB	    PACTIM,CMDTIM,GRDTIM,ESCTIM,TXMT_0,TXMT_0

	  PROG
TRNTIM	  LSLB				;transparent mode timer
	  LDX	    #(TRNTAB-2)
	  JMP	    [B,X]

PACTIM	  LDD	    >PAC_TM		;check packet timeout
	  BEQ	    TXMT_0
	  CMPD	    TN_CLK
	  BGT	    TXMT_0
	  INC	    TRN_FL		;wait for command interval
	  CLR16     TN_CLK		;reset clock
	  TST	    PAC_FL
	  BGT	    TXMT_0
	  BEQ	    PACT_1
	  NEG	    PAC_FL
TXMT_0	  LBRA	    TXMTIM

PACT_1	  LDX	    TTI_IN		;move fence
	  CMPX	    TTI_PK
	  BEQ	    TXMT_0
	  STX	    TTI_PK
	  STX	    TMP_PK
	  DEC	    PAC_FL		;set no-timeout flag
	  BRA	    TXMT_0

CMDTIM	  LDX	    >CMD_TM		;test guard time
	  BEQ	    TXMT_0
	  CMPX	    TN_CLK
	  BGT	    TXMT_0
	  INC	    TRN_FL		;wait for control-Cs
	  LDX	    #CMDCHR		;divert interrupts
	  STX	    TTI_IV
	  BRA	    TXMT_0

GRDTIM	  LDB	    CMD_CT		;see if first character typed
	  BEQ	    TXMT_0
	  LDX	    >CMD_TM		;timeout & back to transparent
	  CMPX	    TN_CLK
	  BGT	    TXMT_0
	  LDA	    SAVE_C		;put control-Cs in input buffer
	  DECB
	  LBRA	    CMDC_2

ESCTIM	  LDX	    >CMD_TM		;check second guard time
	  CMPX	    TN_CLK
	  BGT	    TXMT_0
	  CLR	    CMD_CT
	  INC	    TRN_FL		;make sure last pkts are transp
	  INC	    QSO_FL
	  LDX	    #EATCHR		;reset interrupts
	  STX	    TTI_IV
	  LDX	    TTI_IN
	  CMPX	    TTI_PK
	  BNE	    ESCT_1
	  INC	    TRN_FL		;inc to 6
	  CMPX	    TTI_US
	  BNE	    ESCT_2
	  CLR	    TRN_FL		;done with transp packets
	  BRA	    ESCT_2

ESCT_1	  STX	    TMP_PK
	  LDA	    #0FFH		;set no-timeout flag
	  STA	    PAC_FL
ESCT_2	  LBRA	    CMDBEG		;go to command mode

	  TITLE     "HDLC Communications -- TNC LLR, Margaret Morrison"
; HDLC interrupt servicer

; PKT_ST  0 clear to send
;	  1 sending initial flags
;	  2 sending data
;	  3 data done
;	  4 FCS done
;	  5 starting flags
;	  6 sending flags

; here with count in D, pointer in Y

SNDPKT	  LDX	    PKO_US		;move to output buffer
	  PSHS	    CC,A
	  LBSR	    STDATA		;store high-order byte
	  TFR	    B,A			;store low-order byte
	  LBSR	    STDATA
	  TSTB
	  BEQ	    SNDP_1
	  INC	    1,S
SNDP_1	  LDA	    ,Y+			;move string to packet buffer
	  COMA
	  LBSR	    STDATA
	  DECB
	  BNE	    SNDP_1		;loop on low-order byte
	  DEC	    1,S
	  BNE	    SNDP_1		;loop on high-order byte
	  INCB				;set not-empty bit
	  STB	    ACT_FL

	  LDA	    #ACT
	  LBSR	    SETBIT

	  SEI
	  INC	    PKW_FL
	  STX	    PKO_US		;update pointer
	  PULS	    CC,A,PC		;get rid of counter

; ok to start packet

STTPKT	  LDX	    PKO_OU		;get count
	  CMPX	    PKO_US
	  BNE	    STTP_1
	  BSR	    PKRES
	  STB	    PKW_FL
	  RTS

STTP_1	  LDA	    ,X+
	  BSR	    RNGPKO
	  LDB	    ,X+
	  BSR	    RNGPKO
	  STX	    PKO_OU		;update count
	  DEC	    PKW_FL
	  STD	    PKO_CT		;set up counter

	  TST	    PKT_ST
	  BEQ	    STTP_2

	  STA	    >THR		;continuing packet here
	  LDA	    #1
	  STA	    PKT_ST
	  LDX	    >TXM_TM		;don't send long flags
	  STX	    CS_CLK
	  RTS

STTP_2	  INC	    PKT_ST		;set status
	  LBSR	    MARKON		;turn on tone
	  LDA	    #TXFLAG		;key transmitter & send flags
	  EORA	    TXM_FL
	  STA	    >CR1
	  CLR16     CS_CLK		;start timer
	  LDA	    #0FFH		;not ok to transmit
	  STA	    TOK_FL

	  TST	    AID_FL
	  BEQ	    STTP_4
	  TST	    KEY_FL		;check ID status
	  BGT	    STTP_4
	  BLT	    STTP_3
	  LDA	    #0FFH		;send ID after this TX
	  STA	    IDG_FL
	  RTS

STTP_3	  NEG	    KEY_FL		;flag transmission
STTP_4	  RTS

; This routine MUST return with D clear

SETRAN	  LDB	    ST_CLK+1		;reset random time
	  ANDB	    #0FH
	  LDA	    >TXM_TM+1
	  MUL
	  STD	    RAN_TM
	  CLRA
	  CLRB
	  STD	    CS_CLK
	  RTS

; This routine MUST return with D clear

PKRES	  LBSR	    SPACON		;turn off tone
	  LDA	    #RCVR		;restore receive state
	  STA	    >CR1
	  LDA	    #2
	  STA	    TOK_FL		;just dropped txmt

	  LDA	    #.NT.ACT		;clear ACT output pin
	  LBSR	    CLRBIT

	  BSR	    SETRAN
	  CLR	    PKT_ST		;reset flag
	  CLR	    ACT_FL		;reset buffer-full flag
	  RTS

STDATA	  STA	    ,X+			;store character
RNGPKO	  RING	    PKO_BF,PKO_TP

PACKET	  TFR	    B,DP		;set direct page
	  BITA	    #32H		;skip if no transmit bits set
	  LBEQ	    PACKIN

	  LDB	    PKT_ST		;look up destination from table
	  LSLB
	  LDX	    #PKOTAB
	  JMP	    [B,X]

	  COMN
PKOTAB	  FDB	    PACKIN
	  FDB	    BEGFLG,DATOUT,DATDON,FCSDON,ENDFL1,ENDFL2

	  PROG
FCSDON	  INC	    PKT_ST		;update status
	  LDA	    #TXFLAG		;command flags
	  EORA	    TXM_FL
	  STA	    >CR1
	  LDA	    FLG_NM		;wait "6" flags to drop tx
	  STA	    HNG_TM
	  STA	    >THR
	  LBRA	    PACKIN

ENDFL1	  INC	    PKT_ST		;one interrupt for sure
	  STA	    >THR
	  LBRA	    PACKIN

ENDFL2	  TST	    PKW_FL		;start another packet
	  BEQ	    FLAG_0
	  LBSR	    STTPKT
	  BRA	    PACKIN

FLAG_0	  DEC	    HNG_TM
	  BNE	    FLAG_3
	  TST	    IDG_FL		;send CW id
	  BGE	    FLAG_1
	  CLR	    PKT_ST		;turn off tx indicator
	  LBSR	    CWBEGN
	  BRA	    PACKIN

FLAG_1	  BSR	    PKRES		;turn off transmitter
	  BRA	    PACKIN

BEGFLG	  LDD	    >TXM_TM		;send initial flags
	  CMPD	    CS_CLK		;check keyup time
	  BGT	    FLAG_3
	  LDX	    >RPT_TM		;check repeater delay
	  BEQ	    FLAG_2
	  TST	    DLY_FL
	  BEQ	    FLAG_2
	  LEAX	    D,X
	  CMPX	    CS_CLK
	  BGT	    FLAG_3
FLAG_2	  INC	    PKT_ST		;ready to send data
	  CLR	    DLY_FL
	  LDA	    #TXDATA		;change HDLC mode
	  EORA	    TXM_FL
	  STA	    >CR1
	  BRA	    DATO_1
FLAG_3	  STA	    >THR		;clear interrupt
	  BRA	    PACKIN

DATOUT	  BITA	    #2			;skip if not DRQO
	  BEQ	    PACKIN

DATO_1	  LDX	    PKO_OU		;sending data
	  CMPX	    PKO_US
	  BNE	    PDAT_1
	  CLR16     PKO_CT		;double check buffer
	  BRA	    DATDON

PDAT_1	  LDA	    ,X+			;get character
	  LBSR	    RNGPKO		;update pointer
	  STX	    PKO_OU
	  STA	    >THR		;send character
	  LDX	    PKO_CT		;update counter
	  LEAX	    -1,X
	  STX	    PKO_CT
	  BNE	    PACKIN
	  INC	    PKT_ST		;done with data
	  BRA	    PACKIN

DATDON	  LDA	    #TXFCS		;command FCS
	  EORA	    TXM_FL
	  STA	    >CR1
	  STA	    >THR
	  LDA	    #4
	  STA	    PKT_ST

PACKIN	  LDD	    STATUS
	  BITA	    #0C4H		;test for receive interrupts
	  BEQ	    PKTDSC

	  BITA	    #4H			;here for receive interrupts
	  BEQ	    PKIDON
	  LDX	    PKI_IN		;get pointer
	  LDY	    PKI_CT		;see if beginning
	  BNE	    PKDRQI
	  STX	    PKI_BG		;save count address
	  CLRA
	  LBSR	    INDATA		;leave 2 bytes at beginning
	  LBSR	    INDATA

PKDRQI	  BSR	    RDDATA		;get incoming byte
	  TST	    PKI_FU
	  BNE	    PKIN_1
	  STX	    PKI_IN
	  LEAY	    1,Y			;increment byte count
	  STY	    PKI_CT
PKIN_1	  LDD	    STATUS
	  BITA	    #0C0H
	  BEQ	    PKTDSC

PKIDON	  LDX	    PKI_BG
	  BITA	    #80H		;assume no error if REOM/ok
	  BEQ	    PKIEND
	  TST	    RER_FL
	  BNE	    PKIEND

PKINOK	  LDD	    PKI_CT		;here for pkt received ok
	  SUBD	    #2			;remove FCS
	  TST	    PKI_FL
	  BNE	    PKIN_3		;don't change previous count
	  STD	    HITSZ
PKIN_3	  BSR	    INDATA		;store count at beg. of pkt
	  TFR	    B,A
	  BSR	    INDATA
	  INC	    PKI_FL		;set pkt ready flag
	  LDX	    PKI_IN		;update pointer
	  LEAX	    -1,X
	  BSR	    RNGPBK
	  LEAX	    -1,X
	  BSR	    RNGPBK

PKIEND	  STX	    PKI_IN		;update/flush buffer
	  CLRA
	  CLRB
	  STD	    PKI_CT		;clear count
	  STA	    PKI_FU		;clear full
	  STA	    RER_FL		;clear software error
	  LDD	    STATUS

PKTDSC	  TST	    FDX_FL		;ignore in full-duplex
	  BNE	    PKTD_0

	  BITA	    #8			;test data set change
	  BEQ	    PKTD_1

	  BITB	    #40H		;test carrier-detect
	  BNE	    PKTD_2
PKTD_0	  TST	    DCD_FL		;make sure it's a change
	  BEQ	    PKTD_1

	  LDA	    #((.NT.DCD).AN.0FFH)
	  LBSR	    CLRBIT

	  CLRB
	  STB	    DCD_FL		;set carrier state
	  INCB
	  STB	    DRP_FL		;set drop flag
	  TST	    PKT_ST		;test if transmitting
	  BNE	    PKTD_1
	  TST	    IDG_FL
	  BGT	    PKTD_1

	  TST	    FDX_FL
	  BNE	    PKTD_1

	  INCB
	  STB	    TOK_FL		;set to 2
	  LBSR	    SETRAN
PKTD_1	  RTI

PKTD_2	  LDD	    #1FFH
	  STA	    DCD_FL		;set carrier detect &
	  STB	    TOK_FL		;no transmit
	  LDA	    #DCD
	  LBSR	    SETBIT
	  RTI

RDDATA	  LDA	    >RHR		;clear DRQI
INDATA	  TST	    RER_FL		;make sure buffer not full
	  BNE	    INDT_1
	  STA	    ,X+			;store byte
	  BSR	    RNGPKI		;update pointer
	  CMPX	    PKI_US		;test for now full
	  BNE	    INDT_1
	  INC	    PKI_FU		;set flag
	  INC	    RER_FL		;set software error
INDT_1	  RTS

RNGPKI	  RING	    PKI_BF,PKI_TP
RNGPBK	  CMPX	    PKI_BF
	  BGE	    RNGP_9
	  LDX	    PKI_TP
RNGP_9	  RTS

GTDATA	  LDA	    ,X+			;get byte
	  BSR	    RNGPKI		;update pointer
	  SEI
	  STX	    PKI_US		;clear full flag
	  CLR	    PKI_FU
	  CLI
	  RTS

GETPKT	  PSHS	    D			;save max count
	  LDX	    PKI_US
	  LEAS	    -2,S		;make space
	  BSR	    GTDATA		;get packet count
	  STA	    ,S			;save read count
	  BSR	    GTDATA
	  STA	    1,S
	  LDD	    ,S			;make extra counter copy
	  CMPD	    2,S
	  BLE	    GTPK_0
	  LDD	    2,S
GTPK_0	  PSHS	    D			;get lesser count
GTPK_1	  BSR	    GTDATA		;get byte
	  COMA
	  STA	    ,Y+			;store in string
	  LDD	    ,S			;update counter
	  SUBD	    #1
	  STD	    ,S
	  BNE	    GTPK_1		;loop
	  LEAS	    2,S			;get rid of loop counter
	  PULS	    D
	  SUBD	    ,S++		;check for remainder
	  BLE	    GTPK_3

GTPK_2	  LEAX	    1,X			;clear out buffer
	  BSR	    RNGPKI
	  SUBD	    #1
	  BNE	    GTPK_2

	  SEI
	  STX	    PKI_US		;update pointers
	  CLR	    PKI_FU
	  CLI
GTPK_3	  CLRA				;mop up unfinished packet
	  CLRB
	  SEI
	  DEC	    PKI_FL
	  TST	    PKI_FL
	  BEQ	    GTPK_4
	  LDA	    ,X+
	  BSR	    RNGPKI
	  LDB	    ,X+
	  BSR	    RNGPKI

GTPK_4	  STD	    HITSZ		;update count for next pkt
	  CLI
	  RTS

	  TITLE     "NOVRAM routines -- TNC LLR, Margaret Morrison"
; Load default data into array used by NOVRAM

	  COMN
DEFALT	  FCB	    76H				  ;300 baud, 1 stop, space, 7 bits
	  FCB	    02FH,0F7H,053H,018H		  ;flag words
	  FCB	    80,128			  ;screen, packet
	  FCB	    18H,19H,13H,11H		  ;characters
	  FCB	    16H,12H,0DH,03H
	  FCB	    05H,13H,11H,31
	  ASC	    "	   "			  ;call sign
	  FCB	    09H,0AH,34H			  ;index values
	  FCB	    30H,04H,12H			  ;time values
	  FCB	    0H				  ;beacon
DEFNUM	  EQU	    ($-DEFALT)

	  PROG
GETDEF	  LDB	    #DEFNUM
	  LDX	    #NOVDAT
	  LDY	    #DEFALT
	  LBSR	    BLTRN
	  RTS

; routine to read NOVRAM to data area
; data in NOVRAM is stored 1L 1H 2L 2H ... 32L 32H

	  SETDP     IOPAGE
GETNOV	  PSHS	    A,B,DP,X		;save incoming registers
	  LDA	    #IOPAGE
	  TFR	    A,DP

	  LDX	    #NOVDAT
	  CLR	    VIAB		;start at beginning
	  GetNov    NOVNUM
	  PULS	    A,B,DP,X,PC

GETTER	  LDA	    VIAA		;nibble goes in MSN of A
	  LSRA				;move to LSN of A
	  LSRA
	  LSRA
	  LSRA
	  PSHS	    A			;save LSN
	  INC	    VIAB
	  LDA	    VIAA		;get next part
	  ANDA	    #0F0H		;make sure low order part 0
	  ORA	    ,S+			;combine with LSN
	  INC	    VIAB
	  STA	    ,X+
	  DECB				;decrement counter
	  BNE	    GETTER
	  RTS

; Decode flags from NOVRAM and store at end of NOVRAM array

	  COMN
RFTAB	  FDB	    1E01H,0BE00H,8100H,6900H,5E00H,2E00H,2200H,1600H
;		     50     75	  110	135   150   300   400	600
	  FDB	    1000H,0A00H,0800H,0600H,0400H,0200H,0100H,0
;		     800  1200	1440  1800  2400  3600	4800  *

MULTAB	  FCB	    4,12,12,25,100,4
ADDTAB	  FCB	    0,0,0,0,1,0
	  FCB	    1,0,0,0,0,0
	  FCB	    0,0

	  PROG
	  SETDP     PAGE
DECFLG	  CLR	    ,X+			;zero to start
	  LSLA				;get highest bit
	  BCC	    DECF_1
	  INC	    -1,X		;set flag equal to bit
DECF_1	  DECB
	  BNE	    DECFLG
	  RTS

EXPLOD	  LDX	    #EXPBYT		;convert indices to actual times
	  LDY	    #DOUBYT
	  LDB	    #DUBNUM
	  PSHS	    CC,B,U
	  LDU	    #MULTAB

EXPL_1	  LDD	    ,X++		;get index
	  LDA	    ,U+			;get factor
	  MUL
	  STD	    ,Y++		;store actual time
	  DEC	    1,S			;loop
	  BNE	    EXPL_1
	  LDB	    RFCODE+1		;set HDLC rate
	  LSLB
	  LDX	    #RFTAB		;look up data from table
	  LDD	    B,X
	  CMPD	    RFBAUD		;test if new rate
	  BEQ	    EXPL_3
	  STD	    RFBAUD
EXPL_2	  TST	    PKT_ST		;wait for HDLC idle
	  BNE	    EXPL_2
	  TST	    IDG_FL
	  BGT	    EXPL_2
	  SEI
	  LBSR	    HINIT		;reset HDLC
EXPL_3	  PULS	    CC,B,U,PC

DECNOV	  LDX	    #NOV_FL		;unpack flag array
	  GetFL

	  LDA	    #1BH		;set <escape> character
	  TST	    ESC_FL
	  BNE	    DECN_B
	  LDA	    #24H
DECN_B	  STA	    C_DLLR

	  LDA	    #7FH		;set <delete> character
	  TST	    DEL_FL
	  BNE	    DECN_C
	  LDA	    #08
DECN_C	  STA	    C_DELE

DECHAF	  LDX	    #HAFBYT		;decode half-byte indices
	  LDY	    #INDBYT
	  LDB	    #HAFNUM
	  PSHS	    A,U
	  LDU	    #ADDTAB

DECH_1	  LDA	    ,X+			;get byte
	  STA	    ,S			;save for 2nd half
	  LSRA				;get high half-byte
	  LSRA
	  LSRA
	  LSRA
	  ADDA	    ,U+			;add offset

	  CLR	    ,Y+
	  STA	    ,Y+			;store in double location
	  LDA	    ,S			;get low half byte
	  ANDA	    #0FH
	  ADDA	    ,U+			;add offset
	  CLR	    ,Y+
	  STA	    ,Y+			;store
	  DECB				;loop
	  BNE	    DECH_1

	  PULS	    A,U
	  LBSR	    EXPLOD		;multiply out times

	  LDD	    CALEXT		;fix callsign extension
	  EXG	    A,B
	  STD	    CALEXT
	  LDB	    NUL_NM+1		;fix null count
	  LSLB
	  STB	    NUL_NM+1

	  CLRA
	  LDB	    >Beacon		;get beacon time
	  STD	    BEC_TM
	  LDY	    #NOVBYT		;copy characters & call sign
	  LDB	    ,Y+
	  STD	    SCR_WD
	  LDB	    ,Y+
	  BNE	    DECH_2
	  INCA				;set to 256 if 0 stored
DECH_2	  STD	    PKT_LN

	  LDX	    #BYTLST		;copy main character list
	  LDB	    #BYTNUM
	  LBSR	    BLTRN

	  CLRA				;zero high half of integers
	  STA	    ABAUD
	  STA	    ABIT
	  STA	    AWLEN
	  STA	    PARITY
	  INCA				;set "defaults"
	  STA	    ABIT+1
	  LDA	    #8
	  STA	    AWLEN+1

	  LDB	    >TTCODE		;decode terminal code
	  TFR	    B,A
	  ANDB	    #0FH
	  STB	    ABAUD+1
	  BITA	    #80H
	  BEQ	    DECT_2
	  BITA	    #10H
	  BNE	    DECT_2

	  LDB	    #4
	  STB	    PARITY+1
	  LDB	    #DTR		;no parity here
	  STB	    RONTOF
	  LDB	    #10H		;set baud rate generator
	  BITA	    #20H
	  BEQ	    DECT_1
	  ORB	    #20H		;7 bits, no parity
	  DEC	    AWLEN+1
DECT_1	  BITA	    #40H		;7 or 8
	  BEQ	    DECT_4
	  ORB	    #80H		;2 stop bits
	  INC	    ABIT+1
	  BRA	    DECT_4

DECT_2	  PSHS	    A			;parity
	  LSLA
	  ANDA	    #0C0H
	  ORA	    #(20H+DTR)
	  STA	    RONTOF

	  ROLA				;move 3 spaces (incl carry)
	  ROLA
	  ROLA
	  ANDA	    #3H
	  STA	    PARITY+1

	  PULS	    A
	  CLRB
	  BITA	    #80H
	  BEQ	    DECT_3
	  ORB	    #80H		;2 stop bits
	  INC	    ABIT+1
DECT_3	  BITA	    #10H
	  BEQ	    DECT_4
	  ORB	    #20H		;7 bits
	  DEC	    AWLEN+1

DECT_4	  ORB	    ABAUD+1
	  ORB	    #10H		;enable receiver clock
	  STB	    TTBAUD
	  RTS

; encode NOVRAM

SAVNOV	  PSHS	    A			;save "burn" flag
	  LDA	    PARITY+1		;encode terminal bits
	  CMPA	    #4
	  BEQ	    SAVN_1

	  LSLA				;set parity code
	  LDB	    AWLEN+1
	  CMPB	    #8
	  BEQ	    SAVN_3

	  INCA				;set word code
	  LDB	    ABIT+1		;7-bit char, check stop bits
	  CMPB	    #1
	  BEQ	    SAVN_3
	  ORA	    #8			;2 stop bits
	  BRA	    SAVN_3

SAVN_1	  LDB	    AWLEN+1		;no parity option
	  LDA	    #8			;set no-parity mode
	  CMPB	    #8
	  BEQ	    SAVN_2
	  ORA	    #2			;word length code
SAVN_2	  LDB	    ABIT+1
	  CMPB	    #1
	  BEQ	    SAVN_3
	  ORA	    #4			;stop bit code

SAVN_3	  LSLA				;got code set up
	  LSLA
	  LSLA
	  LSLA
	  ORA	    ABAUD+1		;get baud rate code
	  STA	    >TTCODE

	  LDX	    #NOV_FL		;repack flag bytes
	  SveFL

	  LDX	    #NOVBYT		;copy characters & call sign
	  LDA	    SCR_WD+1
	  STA	    ,X+
	  LDA	    PKT_LN+1
	  STA	    ,X+
	  LDA	    BEC_TM+1		;save beacon time
	  STA	    >Beacon

	  LDY	    #BYTLST		;copy main character list
	  LDB	    #BYTNUM
	  LBSR	    BLTRN

	  LDB	    NUL_NM+1		;fix null count
	  LSRB
	  STB	    NUL_NM+1
	  LDD	    CALEXT		;fix call extension
	  EXG	    A,B
	  STD	    CALEXT

ENCHAF	  LDX	    #HAFBYT		;encode index values
	  LDY	    #INDBYT
	  LDB	    #HAFNUM
	  PSHS	    D,U
	  LDU	    #ADDTAB

ENCH_1	  LDD	    ,Y++
	  SUBB	    ,U+			;high nibble
	  LSLB
	  LSLB
	  LSLB
	  LSLB
	  STB	    ,S
	  LDD	    ,Y++
	  SUBB	    ,U+
	  ANDB	    #0FH		;low nibble
	  ORB	    ,S
	  STB	    ,X+
	  DEC	    1,S
	  BNE	    ENCH_1
	  PULS	    D,U

	  LBSR	    DECNOV		;decode every time

	  BSR	    PUTNOV		;write NOVRAM
	  LDA	    ,S+			;test "burn" flag"
	  BNE	    SAVN_5
	  RTS

SAVN_5	  LDA	    >VIAA		;burn NOVRAM
	  ANDA	    #.NT.STORE
	  STA	    >VIAA
	  ORA	    #STORE
	  STA	    >VIAA
	  RTS

SAVFLG	  LSLA
	  TST	    ,X+
	  BEQ	    SAVF_1
	  INCA
SAVF_1	  DECB
	  BNE	    SAVFLG
	  RTS

	  SETDP     IOPAGE
PUTNOV	  PSHS	    A,B,DP,X		;save registers
	  LDA	    #IOPAGE
	  TFR	    A,DP

	  LDX	    #NOVDAT		;address
	  CLR	    VIAB		;start at beginning
	  PutNov    NOVNUM
	  PULS	    A,B,DP,X,PC

PUTTER	  LDB	    ,X+			;next byte
	  PSHS	    B			;save
	  LSLB				;move LSL to MSN of B
	  LSLB
	  LSLB
	  LSLB
	  BSR	    PUTNIB
	  PULS	    B			;get high half
	  ANDB	    #0F0H
	  BSR	    PUTNIB
	  DECA				;loop
	  BNE	    PUTTER
	  RTS

; enter with data in high half of B, zero in low half

PUTNIB	  ORB	    #STORE		;make sure STORE* is high
	  PSHS	    A,B
	  LDB	    VIAA
	  ANDB	    #(STORE+ADR6)	;don't mess up low half
	  ORB	    1,S
	  LDA	    #.NT.SWIT_1		;get data direction
	  STB	    VIAA		;preset data
	  STA	    DDRA		;all output but switch
	  ORB	    #NOV_WE		;get write-enable back up
	  STB	    VIAA
	  LDA	    #(STORE+NOV_WE+ADR6)
	  STA	    DDRA		;turn data bits around
	  INC	    VIAB		;increment address
	  PULS	    A,B,PC

	  TITLE     "Terminal output -- TNC LLR, Margaret Morrison"

; Ring buffer adjusting routines are RNGOUT, RNGECO, and RNGINP.  They
; adjust pointers for corresponding ring buffers.  Pointer is expected
; in X.  Updated pointer is returned in X.  No other changes are made.
; These routines expect pointer to change by at most one position.

; WRITE   Routine to write a string to terminal.
; Call	  D: character count of string
;	  Y: address of start of string

; Returns D: undefined
;	  Y: updated pointer

; All other registers are preserved.

; Routine transfers string to circular output buffer. It checks
; status of typing and outputs a character if necessary to start
; output flowing via interrupts.  Thereafter, characters are output
; by interrupt routine PUTCHR.

	  PROG

	  IF	    Parallel		;conditional
; Parallel port output interrupt routine

; Send <cr> <lf>
; EOL_ST  1 <lf>
;	 -1 force <cr> at end of screen

	  SETDP     IOPAGE
PAROUT	  LDA	    SSTAT		;test busy line
	  BITA	    #BSY
	  BEQ	    PAREOL
	  LDA	    #3
	  STA	    SCMND
	  RTI

	  SETDP     PAGE
PAREOL	  TFR	    B,DP
	  TST	    QSO_FL
	  BEQ	    PAR_OU
	  TST	    EOL_ST		;send end-of-line stuff
	  BEQ	    PAR_EC
	  BLT	    PARE_C

	  TST	    ALF_FL		;send auto linefeed
	  BNE	    PARL_1
	  CLR	    EOL_ST
	  BRA	    PAR_EC
PARL_1	  LDA	    #LF			;send <lf>
	  STA	    >PIB
	  CLR	    EOL_ST
	  RTI

PARE_C	  LDA	    #CR			;forced <cr>
	  STA	    >PIB
PAR_CR	  LDA	    SCR_WD+1		;reset screen counter
	  STA	    SCR_CT
	  LDA	    #1
	  STA	    EOL_ST
PARE_2	  RTI

PAR_EC	  LDX	    ECO_OU		;check for characters to echo
	  CMPX	    ECO_US
	  BEQ	    PAR_OU
	  LDA	    ,X+			;get character
	  LBSR	    RNGECO		;update pointer
	  STX	    ECO_OU
	  BRA	    PARC_3

PAR_OU	  LDX	    TTO_OU		;get pointer
	  CMPX	    TTO_US		;test done
	  BEQ	    PARC_5
PARC_2	  LDA	    ,X+			;get character
	  LBSR	    RNGOUT		;update pointer
	  STX	    TTO_OU
PARC_3	  STA	    >PIB		;type character
	  TST	    QSO_FL
	  BEQ	    PARC_4

	  CMPA	    #CR			;not in transparent mode
	  BEQ	    PAR_CR
	  CMPA	    #BS
	  BEQ	    PARC_6
	  DEC	    SCR_CT		;update screen count
	  BNE	    PARC_4
	  TST	    SCR_WD+1		;disable if SCREEN=0
	  BEQ	    PARC_4
	  DEC	    EOL_ST		;force <cr> at end of screen
PARC_4	  RTI

PARC_5	  CLR	    TYP_FL		;clear flag
	  RTI

PARC_6	  INC	    SCR_CT		;adjust counter for <bs>
	  RTI

	  ENDIF				;parallel

; Output service routines

	  SETDP     PAGE
WRITE	  TSTB
	  BEQ	    WRIT_1
	  INCA
WRIT_1	  TST	    QSO_FL
	  BEQ	    TWRITE
	  PSHS	    D,X			;save D,X
WRIT_2	  LDA	    ,Y+			;get character
	  TST	    CTO_FL		;test output disposal
	  BNE	    WRIT_6
	  CMPA	    #ESC		;test for escape
	  BNE	    WRIT_3
	  LDA	    C_DLLR
WRIT_3	  TST	    UCS_FL		;upper case modification
	  BNE	    WRIT_4
	  LBSR	    UPPER

WRIT_4	  LDX	    TTO_US		;get pointer
	  STA	    ,X+			;store character
	  BSR	    RNGOUT		;update pointer
	  CMPX	    TTO_OU		;wait for buffer to empty
	  BNE	    WRIT_5
	  LBSR	    TYPEON		;make sure we're typing
	  TST	    CTS_FL		;over-ride flow control
	  BGE	    WRIT_4
	  CLR	    CTS_FL
	  BRA	    WRIT_4
WRIT_5	  STX	    TTO_US
	  LBSR	    TYPEON
WRIT_6	  DEC	    1,S			;loop
	  BNE	    WRIT_2
	  DEC	    ,S
	  BNE	    WRIT_2
	  PULS	    D,X,PC		;return

TWRITE	  PSHS	    A,X			;transparent-mode write
TWRT_1	  LDA	    ,Y+			;get character
	  LDX	    TTO_US		;get pointer
	  STA	    ,X+			;store
	  BSR	    RNGOUT		;update ponter
TWRT_2	  CMPX	    TTO_OU
	  BNE	    TWRT_3		;wait if buffer full
	  LBSR	    TYPEON
	  BRA	    TWRT_2

TWRT_3	  STX	    TTO_US		;store pointer
	  LBSR	    TYPEON		;turn on type
	  DECB				;loop
	  BNE	    TWRT_1
	  DEC	    ,S
	  BNE	    TWRT_1
	  PULS	    A,X,PC

RNGOUT	  RING	    TTO_BF,TTO_TP

; Interrupt output routine.  PUTCHR is default destination in vector
; table.  It first checks for more characters in buffer.  If none,
; it dismisses immediately, after reseting TYP_FL.  Otherwise, it
; gets character, updates pointer, and types character to terminal.
; Counts screen and adds <cr> as needed, fills with <lf> and <nulls>.

PUTCHR
	  IF	    Parallel		;conditional

	  TST	    >ABAUD+1
	  LBEQ	    PAROUT

	  ENDIF				;parallel

	  TFR	    B,DP
	  TST	    XOF_RQ		;C-S requested?
	  BEQ	    PUTC_1
	  DEC	    XOF_RQ		;decrement count
	  LDA	    C_XOF		;send it
	  STA	    >TDR
	  RTI

PUTC_1	  TST	    XON_RQ		;C-Q requested?
	  BEQ	    PUTEOL
	  DEC	    XON_RQ		;decrement count
	  LDA	    C_XON		;send it
	  STA	    >TDR
	  RTI

; Send <cr> <nulls> <lf> <nulls>
; EOL_ST  3 nulls after <cr>
;	  2 <lf>
;	  1 nulls after <lf>

PUTEOL	  TST	    QSO_FL		;send end-of-line stuff
	  BEQ	    PUT_OU		;but not in transparent mode
	  LDA	    EOL_ST
	  BEQ	    PUT_EC		;go to echo section
	  BLT	    PUTE_C

	  LSRA				;test low order bit
	  BCC	    PUT_LF

;	  CLR	    >TDR		;send nulls
	  DEC	    EOL_CT		;decrement count
	  BNE	    PUTE_2
PUTE_1	  DEC	    EOL_ST		;update status
PUTE_2	  RTI

PUT_LF	  TST	    ALF_FL		;add auto linefeed?
	  BNE	    PUTL_1
	  CLR	    EOL_ST
	  BRA	    PUT_EC

PUTL_1	  LDA	    #LF			;send <lf>
	  STA	    >TDR
PUTL_2	  LDA	    #1
	  STA	    EOL_ST
	  TST	    NLL_FL		;send nulls
	  BEQ	    PUTE_1
PUTL_3	  LDA	    NUL_NM+1		;send nulls
	  BEQ	    PUTE_1
	  STA	    EOL_CT
	  RTI

PUTE_C	  LDA	    #CR			;forced <cr>
	  STA	    >TDR
PUT_CR	  LDA	    SCR_WD+1		;reset screen counter
	  STA	    SCR_CT
	  LDA	    #3			;set status for null/lf
	  STA	    EOL_ST
	  TST	    NLC_FL
	  BNE	    PUTL_3		;send nulls after <cr>
	  DEC	    EOL_ST
	  RTI

PUT_EC	  LDX	    ECO_OU		;check for characters to echo
	  CMPX	    ECO_US
	  BEQ	    PUT_OU
	  LDA	    ,X+			;get character
	  BSR	    RNGECO		;update pointer
	  STX	    ECO_OU
	  BRA	    PUTC_3

PUT_OU	  TST	    CTS_FL		;is output stopped?
	  BNE	    PUTC_5
	  LDX	    TTO_OU		;get pointer
	  CMPX	    TTO_US		;test done
	  BEQ	    PUTC_5
PUTC_2	  LDA	    ,X+			;get character
	  LBSR	    RNGOUT		;update pointer
	  STX	    TTO_OU
PUTC_3	  STA	    >TDR		;type character
	  TST	    QSO_FL
	  BEQ	    PUTC_4

	  CMPA	    #CR			;not on transparent mode
	  BEQ	    PUT_CR
	  CMPA	    #LF
	  BEQ	    PUTL_2
	  CMPA	    #BS
	  BEQ	    PUTC_6
	  DEC	    SCR_CT		;update screen count
	  BNE	    PUTC_4
	  TST	    SCR_WD+1		;disable if SCREEN=0
	  BEQ	    PUTC_4
	  DEC	    EOL_ST		;force <cr> at end of screen
PUTC_4	  RTI

PUTC_5	  CLR	    TYP_FL		;clear flag
	  LDB	    #TTO
	  LBSR	    INTOFF		;page ok
	  RTI

PUTC_6	  INC	    SCR_CT		;adjust counter for <bs>
	  RTI

; Routine to fill echo output buffer.  Called by GETCHR.  This routine
; takes care of special echo of <escape>.

RNGECO	  RING	    ECO_BF,ECO_TP

ECHO	  PSHS	    A,X			;echo contents of A
	  TST	    ECO_FL
	  BEQ	    ECHO_2
	  CMPA	    #ESC
	  BNE	    ECHO_1
	  LDA	    C_DLLR
ECHO_1	  LDX	    ECO_US		;get pointer
	  STA	    ,X+			;store character
	  BSR	    RNGECO		;update pointer
	  STX	    ECO_US
	  LBSR	    TYPEON
ECHO_2	  PULS	    A,X,PC

ECOSTR	  LDA	    ,Y+			;put a string into the echo buffer
	  BSR	    ECHO
	  DECB
	  BNE	    ECOSTR
	  RTS

	  TITLE     "Terminal input -- TNC LLR, Margaret Morrison"
; Input interrupt routine.  This routine transfers character from
; terminal to next position in input buffer.  It performs screen
; and buffer editing on receipt of C-X or <backspace>.
; ECHO is called to fill echo buffer.

; Real input interrupt routine -- calls GETCHR as post-processor

RNGTER	  RING	    TER_BF,TER_TP

EATCHR	  TFR	    B,DP
	  ANDA	    #7FH		;read from terminal
	  BEQ	    EATC_1		;0 disables checks

	  CMPA	    C_CTLE		;hard interrupt to debug mode
	  BNE	    EATC_1
	  TST	    BSY_FL
	  LBEQ	    Monbeg
	  RTI

GOTCHR
EATC_1	  LDX	    TER_IN		;get pointer
	  STA	    ,X+			;store
	  BSR	    RNGTER		;update pointer
	  CMPX	    TER_US		;don't over-fill buffer
	  BEQ	    EATC_2
	  STX	    TER_IN
EATC_2	  TST	    BSY_FL		;enter interruptable processor
	  BEQ	    EATC_3
	  RTI
EATC_3	  INC	    BSY_FL		;set flag

GETCHR	  SEI
	  TST	    BSY_FL
	  BGT	    GETC_1
	  CLR	    BSY_FL		;this is a trap for busy clear
	  LBRA	    Monbeg		;by accident

GETC_1	  LDX	    TER_US		;read character from terminal
	  CMPX	    TER_IN		;interrupt buffer
	  BNE	    GETC_2
	  CLR	    BSY_FL		;return
	  RTI

GETC_2	  CLI				;enable
	  LDA	    ,X+			;get character from fast buffer
	  BSR	    RNGTER
	  STX	    TER_US		;update pointer
	  LDX	    TTI_IN
	  TSTA				;all control features disabled
	  LBEQ	    GETREG		;by 0 value

	  LDY	    #(CHRLST-1)
	  LDB	    #MONNUM
	  TST	    DBG_FL		;disable most if monitor on
	  BGT	    GETC_a
	  LDB	    #CHRNUM

GETC_a	  CMPA	    B,Y
	  BEQ	    GETC_b
	  DECB
	  BNE	    GETC_a
	  LBRA	    GETREG

GETC_b	  LDY	    #(SPECLS-2)
	  LSLB
	  JMP	    [B,Y]

	  COMN
SPECLS	  FDB	    GOT_DL,GOT_CX,GOT_CY,GOT_CS,GOT_CQ	    ;all modes
	  FDB	    GOT_CV,GOT_CR,GOT_CP,GOT_CC   ;not debug mode

	  PROG
GOT_CC	  TST	    DBG_FL		;enter command mode
	  LBEQ	    CMDBEG
	  BRA	    GETCHR

GOT_CO	  TST	    CTO_FL		;special cancel-output mode
	  BEQ	    GOTO_1
	  CLR	    CTO_FL		;resume output
	  BRA	    GETCHR

GOTO_1	  INC	    CTO_FL		;halt output
	  LDD	    TTO_US		;flush buffer
	  STD	    TTO_OU
GOTO_2	  BRA	    GETCHR

GOT_CY	  TST	    DBG_FL		;cancel packet in converse mode
	  BNE	    GOT_CO
	  LDD	    TTI_PK		;reset pointers
	  STD	    TTI_CR
	  STD	    TTI_IN
	  PSHS	    D
	  LDD	    TTI_US		;calculate number characters
	  SUBD	    ,S++
	  BGT	    GOTY_1
	  ADDD	    TTI_LN
GOTY_1	  SUBD	    #0AH		;adjust buffer count
	  STD	    TTI_CT
	  LDA	    PKT_LN+1		;reset packet count
	  STA	    PKT_CT
	  BSR	    FLOWON

	  COMN
KLNSTR	  FCB	    KLINE
	  FCB	    CR
KLNLEN	  EQU	    ($-KLNSTR)

BSPSTR	  FCB	    BS,40Q,BS
BSPLEN	  EQU	    ($-BSPSTR)

	  PROG
XLINE	  LDB	    #KLNLEN		;echo kill-char and new prompt
	  LDY	    #KLNSTR
	  TST	    DBG_FL
	  BGE	    XLIN_1
	  LBSR	    ECOSTR
	  LDU	    #PRO_CT
	  PULU	    B,Y
XLIN_1	  LBSR	    ECOSTR
	  LBSR	    XONREQ		;keep data coming
	  LBRA	    GETCHR

GOT_CV	  LBSR	    INSTOR		;quote next character
	  SEI				;save control-V
	  LDX	    TER_US		;any characters waiting?
	  CMPX	    TER_IN		;look for chars in buffer
	  BEQ	    GOTV_2
	  LDA	    ,X+
	  LBSR	    RNGTER
	  STX	    TER_US
	  LDX	    TTI_IN
	  CLI
	  LBRA	    GTRG_a

GOTV_2	  LDX	    #GETANY		;divert interrupts
	  STX	    TTI_IV
	  RTI

GOT_CP	  TST	    DBG_FL		;send packet in converse mode
	  LBNE	    GETREG
	  TST	    CRT_FL		;include in packet ?
	  BNE	    GOTP_1
	  CMPX	    TTI_PK		;don't send 0 packet
	  LBEQ	    GETCHR
	  BRA	    GOTP_2

GOTP_1	  LBSR	    ECHO
GOTP_2	  LBSR	    INSTOR		;save character
GOTP_3	  STX	    TTI_PK		;set pointers
	  STX	    TTI_CR
	  CLR16     TN_CLK		;restart timer in opaque mode
	  LDB	    PKT_LN+1		;reset length counter
	  STB	    PKT_CT
	  BSR	    FLOWON
	  LBRA	    GETCHR

FLOWON	  TST	    CTS_FL		;turn on auto flow
	  BGE	    FLOW_2
FLOW_1	  CLR	    CTS_FL
	  LBSR	    TYPEON
FLOW_2	  RTS

GOT_CS					;start/stop output
GOT_CQ	  TST	    STP_FL		;disable for hardware flow
	  LBEQ	    GETREG
	  TST	    CTS_FL
	  BEQ	    GOTQ_1		;look for C-S if not stopped

	  CMPA	    C_CTLQ		;here if stopped
	  LBNE	    GETREG
	  BSR	    FLOW_1
	  LBRA	    GETCHR

GOTQ_1	  CMPA	    C_CTLS		;here if not stopped
	  LBNE	    GETREG
	  INC	    CTS_FL		;set flag for output routine
	  LBRA	    GETCHR

GOT_CX	  LDD	    TTI_CR		;cancel line
	  STD	    TTI_IN		;reset pointer
	  PSHS	    D			;save
	  LDD	    TTI_US		;calculate buffer length
	  SUBD	    ,S
	  BGT	    GOTX_1
	  ADDD	    TTI_LN
GOTX_1	  SUBD	    #0AH
	  STD	    TTI_CT
	  PULS	    D

	  TST	    DBG_FL
	  BNE	    GOTX_3
	  SUBD	    TTI_PK		;reset packet length
	  BGT	    GOTX_2
	  ADDD	    TTI_LN
	  PSHS	    B
	  LDB	    PKT_LN+1
	  SUBB	    ,S+
GOTX_2	  STB	    PKT_CT		;turn on flow at packet beginning
	  CMPB	    PKT_LN+1
	  BNE	    GOTX_4

GOTX_3	  BSR	    FLOWON		;turn on auto flo
GOTX_4	  LBRA	    XLINE

GOT_DL	  CMPX	    TTI_CR		;delete character
	  LBEQ	    GETCHR		;don't delete past <cr>
	  LEAX	    -1,X		;decrement pointer
	  CMPX	    TTI_BF
	  BGE	    GOTD_1
	  LDX	    TTI_TP
GOTD_1	  STX	    TTI_IN
	  INC16     TTI_CT		;update count
	  TST	    BSP_FL
	  BNE	    GOTD_a
	  LDA	    #KLINE
	  LBSR	    ECHO		;echo <backspace>
	  BRA	    GOTD_b
GOTD_a	  LDB	    #BSPLEN
	  LDY	    #BSPSTR
	  LBSR	    ECOSTR
GOTD_b	  LBSR	    XONREQ		;turn on input
	  TST	    DBG_FL
	  BNE	    GOTD_3
	  INC	    PKT_CT
	  CMPX	    TTI_PK
	  BNE	    GOTD_4
GOTD_2	  LBSR	    FLOWON
	  BRA	    GOTD_4

GOTD_3	  CMPX	    TTI_CR
	  BEQ	    GOTD_2
GOTD_4	  LBRA	    GETCHR

GOT_RT	  TST	    DBG_FL		;carriage-return
	  BEQ	    GTRT_1
	  LBSR	    FLOWON
	  INC	    LIN_FL		;set flag in command or debug
GTRT_1	  LBSR	    INSTOR		;store in buffer
	  STX	    TTI_CR		;set <cr> pointer
	  BRA	    GTRG_1

; redisplay line

GOT_CR	  PSHS	    X			;save current pointer
	  LBSR	    FLOWON
	  LDX	    TTI_CR		;get beginning of line/packet
	  TST	    DBG_FL
	  BNE	    GOTR_1
	  LDX	    TTI_PK
GOTR_1	  CMPX	    ,S			;see if beginning of line
	  BEQ	    GOTR_5		;do nothing at beg. of line

	  LBSR	    WRITECR		;output <cr>
	  TST	    DBG_FL
	  BGE	    GOTR_X
	  LDU	    #PRO_CT		;output new prompt in command mode
	  CLRA
	  PULU	    B,Y
	  LBSR	    WRITE
GOTR_X	  TFR	    X,D
	  SUBD	    ,S			;calculate -(count)
	  BLT	    GOTR_2
	  SUBD	    TTI_LN
GOTR_2	  LEAS	    D,S			;leave space for line on stack
	  TFR	    S,Y
	  PSHS	    D			;save count
	  PSHS	    A,Y			;loop counter
GOTR_3	  LDA	    ,X+			;fill up stack with string
	  LBSR	    RNGINP
	  CMPA	    C_CTLV
	  BEQ	    GOTR_4
	  STA	    ,Y+
GOTR_4	  INCB				;loop on low byte
	  BNE	    GOTR_3
	  INC	    ,S			;loop on high byte
	  BNE	    GOTR_3
	  PULS	    A			;clear D
	  TFR	    Y,D			;calculate actual length to write
	  SUBD	    ,S
	  PULS	    Y			;get starting pointer
	  LBSR	    WRITE		;write the string
	  CLRA				;fix stack
	  CLRB
	  SUBD	    ,S++
	  LEAS	    D,S

GOTR_5	  PULS	    X			;get current pointer
	  LBRA	    GETCHR

; here to store "regular character"

GETREG	  TST	    FLO_FL		;test auto flow for "regular" characters
	  BEQ	    GTRG_0
	  TST	    CTS_FL
	  BNE	    GTRG_0		;don't override real control-S
	  DEC	    CTS_FL
GTRG_0	  CMPA	    #CR			;test for <cr>
	  BEQ	    GOT_RT
GTRG_a	  BSR	    INSTOR		;store in buffer
GTRG_1	  LBSR	    ECHO		;echo
	  TST	    DBG_FL		;don't send packets in monitor mode!
	  BNE	    GTRG_2
	  DEC	    PKT_CT		;update count
	  LBEQ	    GOTP_3
GTRG_2	  LBRA	    GETCHR

INSTOR	  PSHS	    CC,A,X
	  TST	    DBG_FL
	  BLE	    INST_0
	  LBSR	    UPPER
INST_0	  STA	    ,X+			;store character
	  BSR	    RNGINP		;update pointer
	  CMPX	    TTI_US		;don't update if overfull
	  BEQ	    INST_1

	  STX	    2,S
	  STX	    TTI_IN
	  SEI
	  LDX	    TTI_CT		;decrement buffer counter
	  LEAX	    -1,X
	  STX	    TTI_CT
INST_1	  LBSR	    XOFREQ
	  SEI
	  TST	    TMO_FL		;restart opaque mode clock
	  BNE	    INST_3		;on typein
	  CLR16     TN_CLK
INST_3	  PULS	    CC,A,X,PC

;temporary (C-V) interrupts

GETANY	  TFR	    B,DP		;read input character
	  LDX	    #EATCHR		;restore interrupt vector
	  STX	    TTI_IV
	  LDX	    TTI_IN		;get buffer pointer
	  CLI
	  ANDA	    #7FH
	  BRA	    GTRG_a		;store in buffer

RNGINP	  RING	    TTI_BF,TTI_TP

	  TITLE     "Special input -- TNC LLR, Margaret Morrison"
; transparent mode input interrupts

TRNCHR	  TFR	    B,DP		;get input
TRNC_1	  LDX	    TTI_IN		;get pointer
	  TST	    TMO_FL
	  BEQ	    TRNC_2		;clear clock in after mode
	  CMPX	    TTI_PK
	  BNE	    TRNC_3		;clear clock if this 1st char
TRNC_2	  CLR16     TN_CLK

TRNC_3	  LDB	    #1			;make sure data mode
	  STB	    TRN_FL
	  STA	    ,X+			;store character
	  BSR	    RNGINP		;update pointer
	  CMPX	    TTI_US
	  BEQ	    TRNC_6		;test if buffer full
	  STX	    TTI_IN
	  DEC	    PKT_CT		;update counter
	  BNE	    TRNC_5
	  TST	    PAC_FL
	  BNE	    TRNC_4
	  STX	    TTI_PK

TRNC_4	  STX	    TMP_PK		;set temp fence
	  LDB	    PKT_LN+1		;reset packet count
	  STB	    PKT_CT

TRNC_5	  LDX	    TTI_CT		;update buffer count
	  LEAX	    -1,X
	  STX	    TTI_CT
	  LBSR	    XOFREQ
TRNC_6	  RTI

; get control-Cs in exit sequence

CMDCHR	  TFR	    B,DP		;get character
	  LDB	    CMD_CT		;current control-C count
	  BEQ	    CMDC_a
	  CMPA	    SAVE_C		;high bits must match
	  BEQ	    CMDC_b
	  BRA	    CMDC_2

CMDC_a	  PSHS	    A			;save actual character
	  ANDA	    #7FH		;mask out parity
	  CMPA	    C_CTLC
	  PULS	    A			;get char back
	  BNE	    CMDC_2		;restore character

	  STA	    SAVE_C		;save hi bit of command chr
CMDC_b	  CLR16     TN_CLK		;reset clock on each
	  INCB				;increment count
	  CMPB	    #3
	  BEQ	    CMDC_1
	  STB	    CMD_CT		;not done
	  RTI

CMDC_1	  INC	    TRN_FL		;done with control-Cs
	  LDX	    #WATCHR		;set interrupt
	  STX	    TTI_IV
	  RTI

WATCHR	  TFR	    B,DP		;input during guard time
	  LDB	    #3

CMDC_2	  TSTB
	  BNE	    CMDC_4
	  CLR	    CMD_CT
	  LDX	    #TRNCHR
	  STX	    TTI_IV
	  BRA	    TRNC_1

CMDC_4	  PSHS	    A			;save character read
	  CLR	    CMD_CT
	  LDX	    TTI_IN		;get pointer
	  LDY	    TTI_CT		;get buffer count
	  LDA	    SAVE_C

CMDC_3	  BSR	    CMDSTO		;store control-Cs
	  DECB
	  BNE	    CMDC_3
	  LDA	    ,S+			;store character
	  BSR	    CMDSTO

	  CLR16     TN_CLK		;reset clock
	  LDA	    #1			;reset transparent flag
	  STA	    TRN_FL
	  LDX	    #TRNCHR		;put interrupt back
	  STX	    TTI_IV
	  RTI

CMDSTO	  STA	    ,X+			;store character
	  LBSR	    RNGINP		;update pointer
	  CMPX	    TTI_US		;buffer full?
	  BEQ	    CMDS_1
	  DEC	    PKT_CT		;decrement packet count
	  LEAY	    -1,Y		;buffer count
	  STX	    TTI_IN		;store pointer
	  STY	    TTI_CT		;store count (&test)
	  RTS

CMDS_1	  LDX	    TTI_IN		;hardware flow control
	  RTS

; Routine to read a string from terminal, terminating with a <cr>.
; Routine checks TTI_CR and does not read past it.

; Call	  Y: address of beginning of destination of string

; Return  D: number of characters read
;	  Y: updated pointer

GETLIN	  PSHS	    Y
GETL_1	  TST	    LIN_FL
	  BEQ	    GETL_1
	  BSR	    READLN
	  PULS	    Y,PC

READLN	  CLRA				;zero count
	  CLRB
	  PSHS	    D,X
	  LDX	    TTI_US		;get pointer
	  LDB	    #7FH		;set max number of characters
	  TST	    DBG_FL
	  BLE	    READ_1
	  LDB	    #1FH

READ_1	  LDA	    ,X+			;get character
	  LBSR	    RNGINP		;update pointer
	  CMPX	    TTI_CR		;stop at end of line
	  BEQ	    READ_4

	  CMPA	    #CR
	  BEQ	    READ_5

	  CMPA	    C_CTLV		;allow quote character
	  BNE	    READ_2
	  LDA	    ,X+
	  LBSR	    RNGINP

READ_2	  DECB
	  BNE	    READ_3		;spin on too many characters
	  STA	    -1,Y
	  INCB
	  BRA	    READ_1

READ_3	  STA	    ,Y+			;store character
	  INC	    1,S			;increment counter
	  BNE	    READ_1
	  INC	    ,S
	  BRA	    READ_1

READ_4	  CLR	    LIN_FL
	  BRA	    READ_6
READ_5	  DEC	    LIN_FL
READ_6	  STA	    ,Y+
	  TFR	    X,D
	  SEI
	  SUBD	    TTI_US
	  BGE	    READ_7
	  ADDD	    TTI_LN
READ_7	  STX	    TTI_US		;update removal pointer
	  ADDD	    TTI_CT
	  STD	    TTI_CT
	  CLI
	  LBSR	    XONREQ		;re-enable flow control

	  TST	    LIN_FL		;change modes on request
	  BNE	    READ_8
	  TST	    CHG_FL
	  BEQ	    READ_8
	  CLR	    CHG_FL
	  LBSR	    SETMOD
READ_8	  PULS	    D,X,PC

; Routine to read packet from terminal, terminating at max length or
; force-packet character, not updating removal pointer

; Call	  D: count of packet to be read
;	  X: removal pointer
;	  Y: destination

READPK	  TSTB
	  BEQ	    RDPK_0
	  INCA
RDPK_0	  PSHS	    A			;save counter hi byte
	  TST	    OPQ_FL
	  BNE	    RDPK_1
	  TST	    TRN_FL
	  BNE	    TRDPKT

RDPK_1	  LDA	    ,X+			;get next byte
	  BSR	    RNGINS		;update pointer
	  CMPA	    C_CTLV
	  BNE	    RDPK_3
	  LDA	    ,X+
	  BSR	    RNGINS
RDPK_3	  STA	    ,Y+			;store byte
	  CMPA	    #CR
	  BNE	    RDPK_4
	  TST	    BRD_FL
	  BEQ	    RDPK_4
	  LDA	    #LF
	  STA	    ,Y+
RDPK_4	  DECB
	  BNE	    RDPK_1		;loop
	  DEC	    ,S
	  BNE	    RDPK_1

	  PULS	    A,PC		;return

TRDPKT	  LDA	    ,X+			;transparent packet read
	  BSR	    RNGINS
	  STA	    ,Y+
	  DECB
	  BNE	    TRDPKT
	  DEC	    ,S
	  BNE	    TRDPKT
	  PULS	    A,PC

RNGINS	  PSHS	    CC			;update pointer from correct list
	  SEI
	  TST	    DBG_FL
	  BNE	    RNGI_1
	  CMPX	    TTI_TP		;terminal list
	  BLE	    RNGI_2
	  LDX	    TTI_BF
	  PULS	    CC,PC

RNGI_1	  CMPX	    >SCI_TP		;scratch list
	  BLE	    RNGI_2
	  LDX	    >SCI_BF
RNGI_2	  PULS	    CC,PC

; Routine to find next packet pointer

; Call	  X: old pointer

; Return  X: new pointer
;	  Y: count of packet

FINDPK	  SEI
	  LDD	    TTI_PK		;get end of packet
	  TST	    DBG_FL
	  BEQ	    FIND_1
	  LDD	    >SCI_PK		;get pointer from scratch area
FIND_1	  CLI				;enable
	  PSHS	    D			;save pointer
	  LDY	    #0			;zero counter
	  TST	    OPQ_FL
	  BNE	    FIND_2
	  TST	    TRN_FL
	  BNE	    TFNDPK

FIND_2	  CMPY	    PKT_LN		;check max length
	  BEQ	    FOUND
	  CMPX	    ,S			;check pointer at end
	  BEQ	    FOUND
	  LDA	    ,X+			;get character
	  BSR	    RNGINS
	  CMPA	    C_CTLP		;compare with C-P
	  BEQ	    FIND_3
	  CMPA	    C_CTLV
	  BNE	    FIND_4
	  LDA	    ,X+			;get quoted character
	  BSR	    RNGINS
FIND_4	  LEAY	    1,Y			;increment counter
	  CMPA	    #CR
	  BNE	    FIND_2
	  TST	    BRD_FL
	  BEQ	    FIND_2
	  LEAY	    1,Y
	  BRA	    FIND_2		;continue

FIND_3	  TST	    CRT_FL		;include termination?
	  BEQ	    FOUND
	  LEAY	    1,Y
	  CMPA	    #CR
	  BNE	    FOUND
	  TST	    BRD_FL
	  BEQ	    FOUND
	  LEAY	    1,Y

FOUND	  PULS	    D,PC		;return

TFNDPK	  CMPY	    PKT_LN		;find in transparent mode
	  BEQ	    TFOUND
	  CMPX	    ,S
	  BNE	    TFND_1
TFOUND	  PULS	    D,PC

TFND_1	  LDA	    ,X+
	  BSR	    RNGINS
	  LEAY	    1,Y
	  BRA	    TFNDPK

	  TITLE     "Miscellaneous -- TNC LLR, Margaret Morrison"
; Turn on input from terminal after it is turned off
;	  Software -- set flag for PUTCHR
;	  Hardware -- lower !RTS

XONREQ	  TST	    XOF_FL
	  BNE	    XONR_1
	  RTS				;not off -- don't turn on

XONR_1	  PSHS	    CC,A,B		;here if input is off
	  SEI
	  LDD	    TTI_CT		;check if buffer empty enough
	  CMPD	    TTI_NM
	  BLT	    XONR_4

	  IF	    Parallel		;conditional

	  TST	    ABAUD+1
	  BNE	    XONR_0
	  LDB	    #TTI		;enable parallel input interrupts
	  LBSR	    INTON
	  CLR	    XOF_FL
	  PULS	    CC,A,B,PC

	  ENDIF				;parallel

; Ready to turn on input -- check flow control mode

XONR_0	  TST	    XOF_FL		;turn on the way it went off
	  BLT	    XONR_3		;special for hardware flow

	  CLR	    XOF_FL		;software flow
	  INC	    XON_RQ
	  CLR	    TYP_FL		;make sure turned on
	  BSR	    TYPEON
	  PULS	    CC,A,B,PC

XONR_3	  LDB	    #TTO		;hardware flow
	  LBSR	    INTON		;turn on transmitter and !RTS
	  CLR	    XOF_FL
XONR_4	  PULS	    CC,A,B,PC		;page ok

; Turn off input from terminal
;	  Software -- set flag for PUTCHR
;	  Hardware -- raise !RTS

XOFREQ	  PSHS	    CC,D
	  SEI
	  LDD	    TTI_CT		;test if buffer full enough
	  BEQ	    XOFR_0
	  ADDD	    #5			;send control-S after 5 chars
	  BGT	    XOFR_4		;then give up on CPM

XOFR_0
	  IF	    Parallel		;conditional

	  TST	    ABAUD+1		;parallel mode
	  BNE	    XOFR_1
	  TST	    XOF_FL		;only turn off once
	  BNE	    XOFR_4

	  LDB	    #TTI		;disable input interrupts
	  LBSR	    INTOFF
	  DEC	    XOF_FL		;flag off
	  PULS	    CC,D,PC

	  ENDIF				;parallel

XOFR_1	  TST	    QSO_FL		;test if transparent mode
	  BNE	    XOFR_2
	  TST	    TXF_FL		;and TXFLOW on
	  BEQ	    XOFR_3

XOFR_2	  TST	    STP_FL		;now test hardware flow mode
	  BEQ	    XOFR_3
	  TST	    C_XON		;or partial hardware flow
	  BEQ	    XOFR_3

	  INC	    XOF_RQ
	  INC	    XOF_FL
	  BSR	    TYPEON
	  PULS	    CC,D,PC

XOFR_3	  TST	    XOF_FL		;only do hardware flow once
	  BNE	    XOFR_4
	  DEC	    XOF_FL
	  LDB	    #TTO		;turn off interrupt from transmitter
	  LBSR	    INTOFF		;page ok
	  LDA	    >SCMND		;RTS high, keep input interrupts
	  ANDA	    #0F3H
	  STA	    >SCMND
XOFR_4	  PULS	    CC,D,PC

; Here to shut off parallel port

; Turn on output interrupts (if hardware flow not asserted)

TYPEON	  PSHS	    CC,A,B
	  SEI
	  TST	    TYP_FL		;turn on typing
	  BNE	    TYPE_1
	  INC	    TYP_FL

	  IF	    Parallel		;conditional

	  TST	    ABAUD+1
	  BEQ	    TYPE_2

	  ENDIF				;parallel

	  TST	    XOF_FL
	  BLT	    TYPE_1
	  LDB	    #TTO
	  LBSR	    INTON		;page ok
TYPE_1	  PULS	    CC,A,B,PC

	  IF	    Parallel		;conditional

; start typing with parallel port

TYPE_2	  LDA	    >SSTAT		;test busy line
	  BITA	    #BSY
	  BNE	    TYPE_1
	  BSR	    TYPE_3		;get output started again
	  BRA	    TYPE_1

TYPE_3	  SEE
	  PSHS	    CC,A,B,DP,X,Y,U	;push machine state
	  LBRA	    PAROUT

	  ENDIF				;parallel

; DEHEX decodes number until non-number found
; input   Y: start of string

; output  Y: updated address
;	  D: binary number

	  COMN
HEXTAB	  ASC	    "0123456789ABCDEF"	;hex table

	  PROG
DEHEX	  CLRA				;zero number
	  CLRB
	  PSHS	    D,X			;save X, number
	  LDA	    ,Y
	  CMPA	    #"$"
	  BNE	    DEHX_1
	  LEAY	    1,Y
DEHX_1	  LDA	    ,Y+
	  BSR	    UPPER
	  LDX	    #HEXTAB
	  LDB	    #0FH
DEHX_2	  CMPA	    B,X
	  BEQ	    DEHX_3
	  DECB
	  BGE	    DEHX_2
	  LEAY	    -1,Y		;back up counter
	  PULS	    D,X,PC

DEHX_3	  PSHS	    B			;save new nibble
	  LDA	    1,S
	  LDB	    #10H		;get high nibble
	  MUL
	  PSHS	    B
	  LDB	    3,S			;get middle nibbles
	  LDA	    #10H
	  MUL
	  ADDD	    ,S++		;add it all together
	  STD	    ,S
	  BRA	    DEHX_1

; ENHEX encodes a byte
; input   A: byte to be encoded
;	  Y: destination string

; output  Y: updated string

; Encode number and call WRITE

WRTHEX	  LEAS	    -5H,S		;reserve space for output buffer
	  TFR	    S,Y
	  PSHS	    B,Y			;save low half byte
	  BSR	    ENHEX		;encode high half
	  PULS	    A
	  BSR	    ENHEX		;encode low half
	  LDD	    #4			;count bytes
	  PULS	    Y
	  LBSR	    WRITE
	  LEAS	    5H,S		;adjust stack
	  RTS

WRTBYT	  LEAS	    -3H,S		;reserve space for output buffer
	  TFR	    S,Y
	  BSR	    ENHEX		;encode high half
	  LDD	    #2			;count bytes
	  TFR	    S,Y
	  LBSR	    WRITE
	  LEAS	    3H,S		;adjust stack
	  RTS

ENHEX	  PSHS	    A,B,X
	  LDX	    #HEXTAB		;load lookup address
	  LDB	    #10H
	  MUL
	  LDA	    A,X			;get high order hex
	  STA	    ,Y+
	  LDA	    ,S
	  ANDA	    #0FH
	  LDA	    A,X			;get low order hex
	  STA	    ,Y+
	  PULS	    A,B,X,PC

UPPER	  CMPA	    #"a"
	  BLT	    UPPR_1
	  CMPA	    #"z"
	  BGT	    UPPR_1
	  ANDA	    #0DFH
UPPR_1	  RTS

BLTRN	  LDA	    ,Y+			;block transfer Y -> X
	  STA	    ,X+
	  DECB
	  BNE	    BLTRN
	  RTS

SETBIT	  SEI				;set bit in A on PIA
	  TST	    >DIA_FL		;test ok to output
	  BNE	    SETB_1
	  ORA	    >PIA
	  STA	    >PIA
SETB_1	  CLI
	  RTS

CLRBIT	  SEI				;clear bit clear in A
	  TST	    >DIA_FL		;test ok to output
	  BNE	    CLRB_1
	  ANDA	    >PIA
	  STA	    >PIA
CLRB_1	  CLI
	  RTS

NOTICE	  COPYRIGHT			;memory 4
NOTCLN	  EQU	    ($-NOTICE)

	  IF	    Beta

	  ELSE
	  ORG	    (0A000H-NOTCLN)	;memory 1
	  COPYRIGHT
	  ENDIF

	  ORG	    0A000H		;memory 2
	  COPYRIGHT

	  ORG	    0FFF2H		;interrupt vectors
	  FDB	    RESET,RESET,RESET
;		    SWI3  SWI2	FIRQ
	  FDB	    DISPAT,RESET,RESET
;		    IRQ    SWI	 NMI
	  FDB	    RESET
;		    RESTART

